/* CameraView.c generated by valac 0.56.18, the Vala compiler
 * generated from CameraView.vala, do not modify */

/*
 * Copyright (c) 2011-2019 elementary, inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite-7.h>
#include <gst/gst.h>
#include <gst/video/video.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gst/pbutils/pbutils.h>
#include <canberra.h>

#define CAMERA_WIDGETS_CAMERA_VIEW_VIDEO_SRC_NAME "v4l2src"
#define CAMERA_MAIN_WINDOW_ACTION_CHANGE_CAMERA "change_camera"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CAMERA_WIDGETS_TYPE_CAMERA_VIEW (camera_widgets_camera_view_get_type ())
#define CAMERA_WIDGETS_CAMERA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView))
#define CAMERA_WIDGETS_CAMERA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraViewClass))
#define CAMERA_WIDGETS_IS_CAMERA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_WIDGETS_TYPE_CAMERA_VIEW))
#define CAMERA_WIDGETS_IS_CAMERA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_WIDGETS_TYPE_CAMERA_VIEW))
#define CAMERA_WIDGETS_CAMERA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraViewClass))

typedef struct _CameraWidgetsCameraView CameraWidgetsCameraView;
typedef struct _CameraWidgetsCameraViewClass CameraWidgetsCameraViewClass;
typedef struct _CameraWidgetsCameraViewPrivate CameraWidgetsCameraViewPrivate;
enum  {
	CAMERA_WIDGETS_CAMERA_VIEW_0_PROPERTY,
	CAMERA_WIDGETS_CAMERA_VIEW_N_CAMERAS_PROPERTY,
	CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY,
	CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY,
	CAMERA_WIDGETS_CAMERA_VIEW_NUM_PROPERTIES
};
static GParamSpec* camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define CAMERA_TYPE_MAIN_WINDOW (camera_main_window_get_type ())
#define CAMERA_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_TYPE_MAIN_WINDOW, CameraMainWindow))
#define CAMERA_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_TYPE_MAIN_WINDOW, CameraMainWindowClass))
#define CAMERA_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_TYPE_MAIN_WINDOW))
#define CAMERA_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_TYPE_MAIN_WINDOW))
#define CAMERA_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_TYPE_MAIN_WINDOW, CameraMainWindowClass))

typedef struct _CameraMainWindow CameraMainWindow;
typedef struct _CameraMainWindowClass CameraMainWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef enum  {
	CAMERA_UTILS_ACTION_TYPE_PHOTO,
	CAMERA_UTILS_ACTION_TYPE_VIDEO
} CameraUtilsActionType;

#define CAMERA_UTILS_TYPE_ACTION_TYPE (camera_utils_action_type_get_type ())
#define _ca_context_destroy0(var) ((var == NULL) ? NULL : (var = (ca_context_destroy (var), NULL)))
#define _ca_proplist_destroy0(var) ((var == NULL) ? NULL : (var = (ca_proplist_destroy (var), NULL)))
enum  {
	CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_FINISHED_SIGNAL,
	CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_ADDED_SIGNAL,
	CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_REMOVED_SIGNAL,
	CAMERA_WIDGETS_CAMERA_VIEW_NUM_SIGNALS
};
static guint camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_NUM_SIGNALS] = {0};

struct _CameraWidgetsCameraView {
	GtkBox parent_instance;
	CameraWidgetsCameraViewPrivate * priv;
};

struct _CameraWidgetsCameraViewClass {
	GtkBoxClass parent_class;
};

struct _CameraWidgetsCameraViewPrivate {
	GtkStack* stack;
	GtkBox* status_box;
	GranitePlaceholder* no_device_view;
	GtkLabel* status_label;
	GtkPicture* picture;
	GstPipeline* pipeline;
	GstElement* tee;
	GstColorBalance* color_balance;
	GstVideoDirection* hflip;
	GstBin* record_bin;
	GstDevice* current_device;
	guint init_device_timeout_id;
	gint picture_width;
	gint picture_height;
	GstDeviceMonitor* monitor;
	gboolean _recording;
};

struct _Block6Data {
	int _ref_count_;
	CameraWidgetsCameraView* self;
	GstPipeline* picture_pipeline;
};

static gint CameraWidgetsCameraView_private_offset;
static gpointer camera_widgets_camera_view_parent_class = NULL;

VALA_EXTERN GType camera_widgets_camera_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraWidgetsCameraView, g_object_unref)
static void camera_widgets_camera_view_on_camera_added (CameraWidgetsCameraView* self,
                                                 GstDevice* device);
VALA_EXTERN void camera_widgets_camera_view_change_camera (CameraWidgetsCameraView* self,
                                               GstDevice* camera);
static void camera_widgets_camera_view_on_camera_removed (CameraWidgetsCameraView* self,
                                                   GstDevice* device);
VALA_EXTERN guint camera_widgets_camera_view_get_n_cameras (CameraWidgetsCameraView* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean camera_widgets_camera_view_on_bus_message (CameraWidgetsCameraView* self,
                                                    GstBus* bus,
                                                    GstMessage* message);
VALA_EXTERN void camera_widgets_camera_view_start (CameraWidgetsCameraView* self);
static void __lambda5_ (CameraWidgetsCameraView* self,
                 GstDevice* dev);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
VALA_EXTERN gboolean camera_widgets_camera_view_get_recording (CameraWidgetsCameraView* self);
VALA_EXTERN void camera_widgets_camera_view_stop_recording (CameraWidgetsCameraView* self);
static void camera_widgets_camera_view_create_pipeline (CameraWidgetsCameraView* self,
                                                 GstDevice* camera);
VALA_EXTERN GType camera_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraMainWindow, g_object_unref)
static void _gtk_window_destroy_gtk_dialog_response (GtkDialog* _sender,
                                              gint response_id,
                                              gpointer self);
VALA_EXTERN void camera_widgets_camera_view_change_color_balance (CameraWidgetsCameraView* self,
                                                      gdouble brightnesss,
                                                      gdouble contrast);
VALA_EXTERN void camera_widgets_camera_view_take_photo (CameraWidgetsCameraView* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void camera_widgets_camera_view_set_recording (CameraWidgetsCameraView* self,
                                               gboolean value);
VALA_EXTERN gboolean camera_widgets_camera_view_get_horizontal_flip (CameraWidgetsCameraView* self);
VALA_EXTERN GType camera_utils_action_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* camera_utils_get_new_media_filename (CameraUtilsActionType action_type);
static GstPadProbeReturn __lambda6_ (Block6Data* _data6_,
                              GstPad* pad,
                              GstPadProbeInfo* info);
static gboolean ___lambda7_ (Block6Data* _data6_);
static void camera_widgets_camera_view_play_shutter_sound (void);
static gboolean ____lambda7__gsource_func (gpointer self);
static GstPadProbeReturn ___lambda6__gst_pad_probe_callback (GstPad* pad,
                                                      GstPadProbeInfo* info,
                                                      gpointer self);
VALA_EXTERN void camera_widgets_camera_view_start_recording (CameraWidgetsCameraView* self);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ___lambda8_ (CameraWidgetsCameraView* self,
                  GstInstallPluginsReturn _result_);
static void ____lambda8__gst_install_plugins_result_func (GstInstallPluginsReturn _result_,
                                                   gpointer self);
VALA_EXTERN CameraWidgetsCameraView* camera_widgets_camera_view_new (void);
VALA_EXTERN CameraWidgetsCameraView* camera_widgets_camera_view_construct (GType object_type);
VALA_EXTERN void camera_widgets_camera_view_set_horizontal_flip (CameraWidgetsCameraView* self,
                                                     gboolean value);
static GObject * camera_widgets_camera_view_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static gboolean _camera_widgets_camera_view_on_bus_message_gst_bus_func (GstBus* bus,
                                                                  GstMessage* message,
                                                                  gpointer self);
static gboolean _camera_widgets_camera_view___lambda9_ (CameraWidgetsCameraView* self);
static gboolean __camera_widgets_camera_view___lambda9__gsource_func (gpointer self);
static void camera_widgets_camera_view_finalize (GObject * obj);
static GType camera_widgets_camera_view_get_type_once (void);
static void _vala_camera_widgets_camera_view_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_camera_widgets_camera_view_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
camera_widgets_camera_view_get_instance_private (CameraWidgetsCameraView* self)
{
	return G_STRUCT_MEMBER_P (self, CameraWidgetsCameraView_private_offset);
}

static void
camera_widgets_camera_view_on_camera_added (CameraWidgetsCameraView* self,
                                            GstDevice* device)
{
#line 122 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/Widgets/CameraView.vala"
	g_return_if_fail (device != NULL);
#line 123 "../src/Widgets/CameraView.vala"
	if (self->priv->init_device_timeout_id > ((guint) 0)) {
#line 124 "../src/Widgets/CameraView.vala"
		g_source_remove (self->priv->init_device_timeout_id);
#line 125 "../src/Widgets/CameraView.vala"
		self->priv->init_device_timeout_id = (guint) 0;
#line 280 "CameraView.c"
	}
#line 127 "../src/Widgets/CameraView.vala"
	g_signal_emit (self, camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_ADDED_SIGNAL], 0, device);
#line 128 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_change_camera (self, device);
#line 286 "CameraView.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 136 "../src/Widgets/CameraView.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 294 "CameraView.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 136 "../src/Widgets/CameraView.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 302 "CameraView.c"
}

static void
camera_widgets_camera_view_on_camera_removed (CameraWidgetsCameraView* self,
                                              GstDevice* device)
{
	guint _tmp0_;
	guint _tmp1_;
#line 130 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/Widgets/CameraView.vala"
	g_return_if_fail (device != NULL);
#line 131 "../src/Widgets/CameraView.vala"
	g_signal_emit (self, camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_REMOVED_SIGNAL], 0, device);
#line 132 "../src/Widgets/CameraView.vala"
	_tmp0_ = camera_widgets_camera_view_get_n_cameras (self);
#line 132 "../src/Widgets/CameraView.vala"
	_tmp1_ = _tmp0_;
#line 132 "../src/Widgets/CameraView.vala"
	if (_tmp1_ == ((guint) 0)) {
#line 323 "CameraView.c"
		GranitePlaceholder* _tmp2_;
		GtkStack* _tmp3_;
		GranitePlaceholder* _tmp4_;
#line 133 "../src/Widgets/CameraView.vala"
		_tmp2_ = self->priv->no_device_view;
#line 133 "../src/Widgets/CameraView.vala"
		gtk_widget_show ((GtkWidget*) _tmp2_);
#line 134 "../src/Widgets/CameraView.vala"
		_tmp3_ = self->priv->stack;
#line 134 "../src/Widgets/CameraView.vala"
		_tmp4_ = self->priv->no_device_view;
#line 134 "../src/Widgets/CameraView.vala"
		gtk_stack_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
#line 337 "CameraView.c"
	} else {
		GstDeviceMonitor* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
		gconstpointer _tmp8_;
#line 136 "../src/Widgets/CameraView.vala"
		_tmp5_ = self->priv->monitor;
#line 136 "../src/Widgets/CameraView.vala"
		_tmp6_ = gst_device_monitor_get_devices (_tmp5_);
#line 136 "../src/Widgets/CameraView.vala"
		_tmp7_ = _tmp6_;
#line 136 "../src/Widgets/CameraView.vala"
		_tmp8_ = g_list_nth_data (_tmp7_, (guint) 0);
#line 136 "../src/Widgets/CameraView.vala"
		camera_widgets_camera_view_change_camera (self, (GstDevice*) _tmp8_);
#line 136 "../src/Widgets/CameraView.vala"
		(_tmp7_ == NULL) ? NULL : (_tmp7_ = (_g_list_free__g_object_unref0_ (_tmp7_), NULL));
#line 355 "CameraView.c"
	}
}

static gboolean
camera_widgets_camera_view_on_bus_message (CameraWidgetsCameraView* self,
                                           GstBus* bus,
                                           GstMessage* message)
{
	gboolean result;
#line 140 "../src/Widgets/CameraView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 140 "../src/Widgets/CameraView.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 140 "../src/Widgets/CameraView.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 141 "../src/Widgets/CameraView.vala"
	switch (message->type) {
#line 141 "../src/Widgets/CameraView.vala"
		case GST_MESSAGE_DEVICE_ADDED:
#line 375 "CameraView.c"
		{
			GstDevice* device = NULL;
			GstDevice* _tmp0_ = NULL;
			GstDevice* _tmp1_;
#line 144 "../src/Widgets/CameraView.vala"
			gst_message_parse_device_added (message, &_tmp0_);
#line 144 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (device);
#line 144 "../src/Widgets/CameraView.vala"
			device = _tmp0_;
#line 145 "../src/Widgets/CameraView.vala"
			_tmp1_ = device;
#line 145 "../src/Widgets/CameraView.vala"
			camera_widgets_camera_view_on_camera_added (self, _tmp1_);
#line 147 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (device);
#line 147 "../src/Widgets/CameraView.vala"
			break;
#line 394 "CameraView.c"
		}
#line 141 "../src/Widgets/CameraView.vala"
		case GST_MESSAGE_DEVICE_CHANGED:
#line 398 "CameraView.c"
		{
			GstDevice* device = NULL;
			GstDevice* changed_device = NULL;
			GstDevice* _tmp2_ = NULL;
			GstDevice* _tmp3_ = NULL;
			GstDevice* _tmp4_;
			GstDevice* _tmp5_;
#line 150 "../src/Widgets/CameraView.vala"
			gst_message_parse_device_changed (message, &_tmp2_, &_tmp3_);
#line 150 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (device);
#line 150 "../src/Widgets/CameraView.vala"
			device = _tmp2_;
#line 150 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (changed_device);
#line 150 "../src/Widgets/CameraView.vala"
			changed_device = _tmp3_;
#line 151 "../src/Widgets/CameraView.vala"
			_tmp4_ = changed_device;
#line 151 "../src/Widgets/CameraView.vala"
			camera_widgets_camera_view_on_camera_removed (self, _tmp4_);
#line 152 "../src/Widgets/CameraView.vala"
			_tmp5_ = device;
#line 152 "../src/Widgets/CameraView.vala"
			camera_widgets_camera_view_on_camera_added (self, _tmp5_);
#line 154 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (changed_device);
#line 154 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (device);
#line 154 "../src/Widgets/CameraView.vala"
			break;
#line 430 "CameraView.c"
		}
#line 141 "../src/Widgets/CameraView.vala"
		case GST_MESSAGE_DEVICE_REMOVED:
#line 434 "CameraView.c"
		{
			GstDevice* device = NULL;
			GstDevice* _tmp6_ = NULL;
			GstDevice* _tmp7_;
#line 157 "../src/Widgets/CameraView.vala"
			gst_message_parse_device_removed (message, &_tmp6_);
#line 157 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (device);
#line 157 "../src/Widgets/CameraView.vala"
			device = _tmp6_;
#line 158 "../src/Widgets/CameraView.vala"
			_tmp7_ = device;
#line 158 "../src/Widgets/CameraView.vala"
			camera_widgets_camera_view_on_camera_removed (self, _tmp7_);
#line 160 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (device);
#line 160 "../src/Widgets/CameraView.vala"
			break;
#line 453 "CameraView.c"
		}
		default:
		{
#line 162 "../src/Widgets/CameraView.vala"
			break;
#line 459 "CameraView.c"
		}
	}
#line 165 "../src/Widgets/CameraView.vala"
	result = G_SOURCE_CONTINUE;
#line 165 "../src/Widgets/CameraView.vala"
	return result;
#line 466 "CameraView.c"
}

static void
__lambda5_ (CameraWidgetsCameraView* self,
            GstDevice* dev)
{
#line 169 "../src/Widgets/CameraView.vala"
	g_return_if_fail (dev != NULL);
#line 170 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_on_camera_added (self, dev);
#line 477 "CameraView.c"
}

static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
#line 169 "../src/Widgets/CameraView.vala"
	__lambda5_ ((CameraWidgetsCameraView*) self, (GstDevice*) data);
#line 486 "CameraView.c"
}

void
camera_widgets_camera_view_start (CameraWidgetsCameraView* self)
{
	GstDeviceMonitor* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GstDeviceMonitor* _tmp3_;
#line 168 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/Widgets/CameraView.vala"
	_tmp0_ = self->priv->monitor;
#line 169 "../src/Widgets/CameraView.vala"
	_tmp1_ = gst_device_monitor_get_devices (_tmp0_);
#line 169 "../src/Widgets/CameraView.vala"
	_tmp2_ = _tmp1_;
#line 169 "../src/Widgets/CameraView.vala"
	g_list_foreach (_tmp2_, ___lambda5__gfunc, self);
#line 169 "../src/Widgets/CameraView.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 172 "../src/Widgets/CameraView.vala"
	_tmp3_ = self->priv->monitor;
#line 172 "../src/Widgets/CameraView.vala"
	gst_device_monitor_start (_tmp3_);
#line 512 "CameraView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 197 "../src/Widgets/CameraView.vala"
	return self ? g_object_ref (self) : NULL;
#line 520 "CameraView.c"
}

void
camera_widgets_camera_view_change_camera (CameraWidgetsCameraView* self,
                                          GstDevice* camera)
{
	GtkStack* _tmp0_;
	GtkBox* _tmp1_;
	GtkLabel* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	GstBin* _tmp9_;
	GstPipeline* _tmp13_;
	GstDevice* _tmp17_;
	GtkRoot* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GVariant* _tmp22_;
	GVariant* _tmp23_;
#line 175 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/Widgets/CameraView.vala"
	g_return_if_fail (camera != NULL);
#line 176 "../src/Widgets/CameraView.vala"
	_tmp0_ = self->priv->stack;
#line 176 "../src/Widgets/CameraView.vala"
	_tmp1_ = self->priv->status_box;
#line 176 "../src/Widgets/CameraView.vala"
	gtk_stack_set_visible_child (_tmp0_, (GtkWidget*) _tmp1_);
#line 177 "../src/Widgets/CameraView.vala"
	_tmp2_ = self->priv->status_label;
#line 177 "../src/Widgets/CameraView.vala"
	_tmp3_ = gst_device_get_display_name (camera);
#line 177 "../src/Widgets/CameraView.vala"
	_tmp4_ = _tmp3_;
#line 177 "../src/Widgets/CameraView.vala"
	_tmp5_ = _tmp4_;
#line 177 "../src/Widgets/CameraView.vala"
	_tmp6_ = g_strdup_printf (_ ("Connecting to \"%s\"…"), _tmp5_);
#line 177 "../src/Widgets/CameraView.vala"
	_tmp7_ = _tmp6_;
#line 177 "../src/Widgets/CameraView.vala"
	gtk_label_set_label (_tmp2_, _tmp7_);
#line 177 "../src/Widgets/CameraView.vala"
	_g_free0 (_tmp7_);
#line 177 "../src/Widgets/CameraView.vala"
	_g_free0 (_tmp5_);
#line 179 "../src/Widgets/CameraView.vala"
	_tmp8_ = self->priv->_recording;
#line 179 "../src/Widgets/CameraView.vala"
	if (_tmp8_) {
#line 180 "../src/Widgets/CameraView.vala"
		camera_widgets_camera_view_stop_recording (self);
#line 579 "CameraView.c"
	}
#line 183 "../src/Widgets/CameraView.vala"
	_tmp9_ = self->priv->record_bin;
#line 183 "../src/Widgets/CameraView.vala"
	if (_tmp9_ != NULL) {
#line 585 "CameraView.c"
		GstBin* _tmp10_;
		GstBin* _tmp11_;
		GstBin* _tmp12_;
#line 184 "../src/Widgets/CameraView.vala"
		_tmp10_ = self->priv->record_bin;
#line 184 "../src/Widgets/CameraView.vala"
		gst_element_set_state ((GstElement*) _tmp10_, GST_STATE_NULL);
#line 185 "../src/Widgets/CameraView.vala"
		_tmp11_ = self->priv->record_bin;
#line 185 "../src/Widgets/CameraView.vala"
		gst_element_sync_state_with_parent ((GstElement*) _tmp11_);
#line 186 "../src/Widgets/CameraView.vala"
		_tmp12_ = self->priv->record_bin;
#line 186 "../src/Widgets/CameraView.vala"
		gst_bin_sync_children_states (_tmp12_);
#line 601 "CameraView.c"
	}
#line 189 "../src/Widgets/CameraView.vala"
	_tmp13_ = self->priv->pipeline;
#line 189 "../src/Widgets/CameraView.vala"
	if (_tmp13_ != NULL) {
#line 607 "CameraView.c"
		GstPipeline* _tmp14_;
		GstPipeline* _tmp15_;
		GstPipeline* _tmp16_;
#line 190 "../src/Widgets/CameraView.vala"
		_tmp14_ = self->priv->pipeline;
#line 190 "../src/Widgets/CameraView.vala"
		gst_element_set_state ((GstElement*) _tmp14_, GST_STATE_NULL);
#line 191 "../src/Widgets/CameraView.vala"
		_tmp15_ = self->priv->pipeline;
#line 191 "../src/Widgets/CameraView.vala"
		gst_bin_sync_children_states ((GstBin*) _tmp15_);
#line 193 "../src/Widgets/CameraView.vala"
		_tmp16_ = self->priv->pipeline;
#line 193 "../src/Widgets/CameraView.vala"
		GST_DEBUG_BIN_TO_DOT_FILE ((GstBin*) _tmp16_, GST_DEBUG_GRAPH_SHOW_VERBOSE, "changing");
#line 623 "CameraView.c"
	}
#line 196 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_create_pipeline (self, camera);
#line 197 "../src/Widgets/CameraView.vala"
	_tmp17_ = _g_object_ref0 (camera);
#line 197 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->current_device);
#line 197 "../src/Widgets/CameraView.vala"
	self->priv->current_device = _tmp17_;
#line 199 "../src/Widgets/CameraView.vala"
	_tmp18_ = gtk_widget_get_root ((GtkWidget*) self);
#line 199 "../src/Widgets/CameraView.vala"
	_tmp19_ = gst_object_get_name ((GstObject*) camera);
#line 199 "../src/Widgets/CameraView.vala"
	_tmp20_ = _tmp19_;
#line 199 "../src/Widgets/CameraView.vala"
	_tmp21_ = _tmp20_;
#line 199 "../src/Widgets/CameraView.vala"
	_tmp22_ = g_variant_new_string (_tmp21_);
#line 199 "../src/Widgets/CameraView.vala"
	g_variant_ref_sink (_tmp22_);
#line 199 "../src/Widgets/CameraView.vala"
	_tmp23_ = _tmp22_;
#line 199 "../src/Widgets/CameraView.vala"
	g_action_group_change_action_state ((GActionGroup*) G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, CAMERA_TYPE_MAIN_WINDOW, CameraMainWindow), CAMERA_MAIN_WINDOW_ACTION_CHANGE_CAMERA, _tmp23_);
#line 199 "../src/Widgets/CameraView.vala"
	_g_variant_unref0 (_tmp23_);
#line 199 "../src/Widgets/CameraView.vala"
	_g_free0 (_tmp21_);
#line 653 "CameraView.c"
}

static void
_gtk_window_destroy_gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
#line 269 "../src/Widgets/CameraView.vala"
	gtk_window_destroy ((GtkWindow*) self);
#line 663 "CameraView.c"
}

static void
camera_widgets_camera_view_create_pipeline (CameraWidgetsCameraView* self,
                                            GstDevice* camera)
{
	GError* _inner_error0_ = NULL;
#line 205 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/Widgets/CameraView.vala"
	g_return_if_fail (camera != NULL);
#line 675 "CameraView.c"
	{
		GstCaps* caps = NULL;
		GstCaps* _tmp0_;
		gint max_area = 0;
		GstElement* device_src = NULL;
		GstElement* _tmp12_;
		GstElement* _tmp13_;
		GstElement* _tmp14_ = NULL;
		GstElement* _tmp15_;
		GstPipeline* _tmp16_;
		GstPipeline* _tmp17_;
		GstPipeline* _tmp18_;
		GstElement* _tmp19_;
		GstElement* _tmp20_;
		GstPipeline* _tmp21_;
		GstElement* _tmp22_;
		GstPipeline* _tmp23_;
		GstElement* _tmp24_;
		GstVideoDirection* _tmp25_;
		GstPipeline* _tmp26_;
		GstElement* _tmp27_;
		GstColorBalance* _tmp28_;
		GstElement* videorate = NULL;
		GstPipeline* _tmp29_;
		GstElement* _tmp30_;
		GstElement* _tmp31_;
		GstElement* _tmp32_;
		GstElement* gtksink = NULL;
		GstElement* _tmp33_;
		GstPipeline* _tmp34_;
		GstElement* _tmp35_;
		GstPipeline* _tmp36_;
		GstElement* _tmp37_;
		GstElement* _tmp38_;
		GstElement* _tmp39_;
		GdkPaintable* gst_video_widget = NULL;
		GstElement* _tmp40_;
		GdkPaintable* _tmp41_ = NULL;
		GtkPicture* _tmp42_;
		GdkPaintable* _tmp43_;
		GtkStack* _tmp44_;
		GtkPicture* _tmp45_;
		GstPipeline* _tmp46_;
#line 207 "../src/Widgets/CameraView.vala"
		_tmp0_ = gst_device_get_caps (camera);
#line 207 "../src/Widgets/CameraView.vala"
		caps = _tmp0_;
#line 208 "../src/Widgets/CameraView.vala"
		self->priv->picture_width = 640;
#line 209 "../src/Widgets/CameraView.vala"
		self->priv->picture_height = 480;
#line 210 "../src/Widgets/CameraView.vala"
		max_area = self->priv->picture_width * self->priv->picture_height;
#line 729 "CameraView.c"
		{
			guint i = 0U;
#line 212 "../src/Widgets/CameraView.vala"
			i = (guint) 0;
#line 734 "CameraView.c"
			{
				gboolean _tmp1_ = FALSE;
#line 212 "../src/Widgets/CameraView.vala"
				_tmp1_ = TRUE;
#line 212 "../src/Widgets/CameraView.vala"
				while (TRUE) {
#line 741 "CameraView.c"
					GstCaps* _tmp3_;
					GstStructure* s = NULL;
					GstCaps* _tmp4_;
					GstStructure* _tmp5_;
					GstStructure* _tmp6_;
					const gchar* _tmp7_;
#line 212 "../src/Widgets/CameraView.vala"
					if (!_tmp1_) {
#line 750 "CameraView.c"
						guint _tmp2_;
#line 212 "../src/Widgets/CameraView.vala"
						_tmp2_ = i;
#line 212 "../src/Widgets/CameraView.vala"
						i = _tmp2_ + 1;
#line 756 "CameraView.c"
					}
#line 212 "../src/Widgets/CameraView.vala"
					_tmp1_ = FALSE;
#line 212 "../src/Widgets/CameraView.vala"
					_tmp3_ = caps;
#line 212 "../src/Widgets/CameraView.vala"
					if (!(i < gst_caps_get_size (_tmp3_))) {
#line 212 "../src/Widgets/CameraView.vala"
						break;
#line 766 "CameraView.c"
					}
#line 213 "../src/Widgets/CameraView.vala"
					_tmp4_ = caps;
#line 213 "../src/Widgets/CameraView.vala"
					_tmp5_ = gst_caps_get_structure (_tmp4_, i);
#line 213 "../src/Widgets/CameraView.vala"
					s = _tmp5_;
#line 214 "../src/Widgets/CameraView.vala"
					_tmp6_ = s;
#line 214 "../src/Widgets/CameraView.vala"
					_tmp7_ = gst_structure_get_name (_tmp6_);
#line 214 "../src/Widgets/CameraView.vala"
					if (g_strcmp0 (_tmp7_, "image/jpeg") == 0) {
#line 780 "CameraView.c"
						gint w = 0;
						gint h = 0;
						GstStructure* _tmp8_;
						gint _tmp9_ = 0;
						GstStructure* _tmp10_;
						gint _tmp11_ = 0;
#line 216 "../src/Widgets/CameraView.vala"
						_tmp8_ = s;
#line 216 "../src/Widgets/CameraView.vala"
						gst_structure_get_int (_tmp8_, "width", &_tmp9_);
#line 216 "../src/Widgets/CameraView.vala"
						w = _tmp9_;
#line 217 "../src/Widgets/CameraView.vala"
						_tmp10_ = s;
#line 217 "../src/Widgets/CameraView.vala"
						gst_structure_get_int (_tmp10_, "height", &_tmp11_);
#line 217 "../src/Widgets/CameraView.vala"
						h = _tmp11_;
#line 218 "../src/Widgets/CameraView.vala"
						if ((w * h) > max_area) {
#line 219 "../src/Widgets/CameraView.vala"
							self->priv->picture_width = w;
#line 220 "../src/Widgets/CameraView.vala"
							self->priv->picture_height = h;
#line 221 "../src/Widgets/CameraView.vala"
							max_area = w * h;
#line 807 "CameraView.c"
						}
					}
				}
			}
		}
#line 226 "../src/Widgets/CameraView.vala"
		_tmp12_ = gst_device_create_element (camera, CAMERA_WIDGETS_CAMERA_VIEW_VIDEO_SRC_NAME);
#line 226 "../src/Widgets/CameraView.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 226 "../src/Widgets/CameraView.vala"
		device_src = _tmp13_;
#line 227 "../src/Widgets/CameraView.vala"
		_tmp15_ = gst_parse_launch_full ("decodebin name=decodebin ! " "videoflip method=horizontal-flip name=hflip ! " "videobalance name=balance ! " "tee name=tee ! " "videorate name=videorate ! " "queue leaky=downstream max-size-buffers=10 ! " "videoconvert ! " "videoscale name=videoscale", NULL, GST_PARSE_FLAG_NONE, &_inner_error0_);
#line 227 "../src/Widgets/CameraView.vala"
		if (_tmp15_ != NULL) {
#line 227 "../src/Widgets/CameraView.vala"
			g_object_ref_sink (_tmp15_);
#line 825 "CameraView.c"
		}
#line 227 "../src/Widgets/CameraView.vala"
		_tmp14_ = _tmp15_;
#line 227 "../src/Widgets/CameraView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 227 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (device_src);
#line 227 "../src/Widgets/CameraView.vala"
			_gst_caps_unref0 (caps);
#line 835 "CameraView.c"
			goto __catch0_g_error;
		}
#line 227 "../src/Widgets/CameraView.vala"
		_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gst_pipeline_get_type (), GstPipeline));
#line 227 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (self->priv->pipeline);
#line 227 "../src/Widgets/CameraView.vala"
		self->priv->pipeline = _tmp16_;
#line 238 "../src/Widgets/CameraView.vala"
		_tmp17_ = self->priv->pipeline;
#line 238 "../src/Widgets/CameraView.vala"
		gst_bin_add ((GstBin*) _tmp17_, device_src);
#line 239 "../src/Widgets/CameraView.vala"
		_tmp18_ = self->priv->pipeline;
#line 239 "../src/Widgets/CameraView.vala"
		_tmp19_ = gst_bin_get_by_name ((GstBin*) _tmp18_, "decodebin");
#line 239 "../src/Widgets/CameraView.vala"
		_tmp20_ = _tmp19_;
#line 239 "../src/Widgets/CameraView.vala"
		gst_element_link (device_src, _tmp20_);
#line 239 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (_tmp20_);
#line 240 "../src/Widgets/CameraView.vala"
		_tmp21_ = self->priv->pipeline;
#line 240 "../src/Widgets/CameraView.vala"
		_tmp22_ = gst_bin_get_by_name ((GstBin*) _tmp21_, "tee");
#line 240 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (self->priv->tee);
#line 240 "../src/Widgets/CameraView.vala"
		self->priv->tee = _tmp22_;
#line 241 "../src/Widgets/CameraView.vala"
		_tmp23_ = self->priv->pipeline;
#line 241 "../src/Widgets/CameraView.vala"
		_tmp24_ = gst_bin_get_by_name ((GstBin*) _tmp23_, "hflip");
#line 241 "../src/Widgets/CameraView.vala"
		_tmp25_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp24_, gst_video_direction_get_type ()) ? ((GstVideoDirection*) _tmp24_) : NULL;
#line 241 "../src/Widgets/CameraView.vala"
		if (_tmp25_ == NULL) {
#line 241 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (_tmp24_);
#line 876 "CameraView.c"
		}
#line 241 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (self->priv->hflip);
#line 241 "../src/Widgets/CameraView.vala"
		self->priv->hflip = _tmp25_;
#line 242 "../src/Widgets/CameraView.vala"
		_tmp26_ = self->priv->pipeline;
#line 242 "../src/Widgets/CameraView.vala"
		_tmp27_ = gst_bin_get_by_name ((GstBin*) _tmp26_, "balance");
#line 242 "../src/Widgets/CameraView.vala"
		_tmp28_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, gst_color_balance_get_type ()) ? ((GstColorBalance*) _tmp27_) : NULL;
#line 242 "../src/Widgets/CameraView.vala"
		if (_tmp28_ == NULL) {
#line 242 "../src/Widgets/CameraView.vala"
			_g_object_unref0 (_tmp27_);
#line 892 "CameraView.c"
		}
#line 242 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (self->priv->color_balance);
#line 242 "../src/Widgets/CameraView.vala"
		self->priv->color_balance = _tmp28_;
#line 244 "../src/Widgets/CameraView.vala"
		_tmp29_ = self->priv->pipeline;
#line 244 "../src/Widgets/CameraView.vala"
		_tmp30_ = gst_bin_get_by_name ((GstBin*) _tmp29_, "videorate");
#line 244 "../src/Widgets/CameraView.vala"
		videorate = _tmp30_;
#line 245 "../src/Widgets/CameraView.vala"
		_tmp31_ = videorate;
#line 245 "../src/Widgets/CameraView.vala"
		g_object_set (_tmp31_, "max-rate", 30, NULL);
#line 246 "../src/Widgets/CameraView.vala"
		_tmp32_ = videorate;
#line 246 "../src/Widgets/CameraView.vala"
		g_object_set (_tmp32_, "drop-only", TRUE, NULL);
#line 248 "../src/Widgets/CameraView.vala"
		_tmp33_ = gst_element_factory_make ("gtk4paintablesink", "sink");
#line 248 "../src/Widgets/CameraView.vala"
		if (_tmp33_ != NULL) {
#line 248 "../src/Widgets/CameraView.vala"
			g_object_ref_sink (_tmp33_);
#line 918 "CameraView.c"
		}
#line 248 "../src/Widgets/CameraView.vala"
		gtksink = _tmp33_;
#line 250 "../src/Widgets/CameraView.vala"
		_tmp34_ = self->priv->pipeline;
#line 250 "../src/Widgets/CameraView.vala"
		_tmp35_ = gtksink;
#line 250 "../src/Widgets/CameraView.vala"
		gst_bin_add ((GstBin*) _tmp34_, _tmp35_);
#line 251 "../src/Widgets/CameraView.vala"
		_tmp36_ = self->priv->pipeline;
#line 251 "../src/Widgets/CameraView.vala"
		_tmp37_ = gst_bin_get_by_name ((GstBin*) _tmp36_, "videoscale");
#line 251 "../src/Widgets/CameraView.vala"
		_tmp38_ = _tmp37_;
#line 251 "../src/Widgets/CameraView.vala"
		_tmp39_ = gtksink;
#line 251 "../src/Widgets/CameraView.vala"
		gst_element_link (_tmp38_, _tmp39_);
#line 251 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (_tmp38_);
#line 254 "../src/Widgets/CameraView.vala"
		_tmp40_ = gtksink;
#line 254 "../src/Widgets/CameraView.vala"
		g_object_get ((GObject*) _tmp40_, "paintable", &_tmp41_, NULL);
#line 254 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (gst_video_widget);
#line 254 "../src/Widgets/CameraView.vala"
		gst_video_widget = _tmp41_;
#line 256 "../src/Widgets/CameraView.vala"
		_tmp42_ = self->priv->picture;
#line 256 "../src/Widgets/CameraView.vala"
		_tmp43_ = gst_video_widget;
#line 256 "../src/Widgets/CameraView.vala"
		gtk_picture_set_paintable (_tmp42_, _tmp43_);
#line 258 "../src/Widgets/CameraView.vala"
		_tmp44_ = self->priv->stack;
#line 258 "../src/Widgets/CameraView.vala"
		_tmp45_ = self->priv->picture;
#line 258 "../src/Widgets/CameraView.vala"
		gtk_stack_set_visible_child (_tmp44_, (GtkWidget*) _tmp45_);
#line 259 "../src/Widgets/CameraView.vala"
		_tmp46_ = self->priv->pipeline;
#line 259 "../src/Widgets/CameraView.vala"
		gst_element_set_state ((GstElement*) _tmp46_, GST_STATE_PLAYING);
#line 206 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (gst_video_widget);
#line 206 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (gtksink);
#line 206 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (videorate);
#line 206 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (_tmp14_);
#line 206 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (device_src);
#line 206 "../src/Widgets/CameraView.vala"
		_gst_caps_unref0 (caps);
#line 976 "CameraView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GraniteMessageDialog* dialog = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
		GraniteMessageDialog* _tmp49_;
		GraniteMessageDialog* _tmp50_;
		GraniteMessageDialog* _tmp51_;
		GraniteMessageDialog* _tmp52_;
#line 206 "../src/Widgets/CameraView.vala"
		e = _inner_error0_;
#line 206 "../src/Widgets/CameraView.vala"
		_inner_error0_ = NULL;
#line 263 "../src/Widgets/CameraView.vala"
		_tmp47_ = e;
#line 263 "../src/Widgets/CameraView.vala"
		_tmp48_ = _tmp47_->message;
#line 263 "../src/Widgets/CameraView.vala"
		_tmp49_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Unable To View Camera"), _tmp48_, "dialog-error", GTK_BUTTONS_CLOSE);
#line 263 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp49_);
#line 263 "../src/Widgets/CameraView.vala"
		dialog = _tmp49_;
#line 268 "../src/Widgets/CameraView.vala"
		_tmp50_ = dialog;
#line 268 "../src/Widgets/CameraView.vala"
		gtk_window_present ((GtkWindow*) _tmp50_);
#line 269 "../src/Widgets/CameraView.vala"
		_tmp51_ = dialog;
#line 269 "../src/Widgets/CameraView.vala"
		_tmp52_ = dialog;
#line 269 "../src/Widgets/CameraView.vala"
		g_signal_connect_object ((GtkDialog*) _tmp51_, "response", (GCallback) _gtk_window_destroy_gtk_dialog_response, (GtkWindow*) _tmp52_, 0);
#line 206 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (dialog);
#line 206 "../src/Widgets/CameraView.vala"
		_g_error_free0 (e);
#line 1017 "CameraView.c"
	}
	__finally0:
#line 206 "../src/Widgets/CameraView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/Widgets/CameraView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "../src/Widgets/CameraView.vala"
		g_clear_error (&_inner_error0_);
#line 206 "../src/Widgets/CameraView.vala"
		return;
#line 1028 "CameraView.c"
	}
}

void
camera_widgets_camera_view_change_color_balance (CameraWidgetsCameraView* self,
                                                 gdouble brightnesss,
                                                 gdouble contrast)
{
	GstColorBalance* _tmp0_;
	GValue _tmp1_ = {0};
	GstColorBalance* _tmp2_;
	GValue _tmp3_ = {0};
#line 273 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/Widgets/CameraView.vala"
	_tmp0_ = self->priv->color_balance;
#line 274 "../src/Widgets/CameraView.vala"
	g_value_init (&_tmp1_, G_TYPE_DOUBLE);
#line 274 "../src/Widgets/CameraView.vala"
	g_value_set_double (&_tmp1_, brightnesss);
#line 274 "../src/Widgets/CameraView.vala"
	g_object_set_property ((GObject*) _tmp0_, "brightness", &_tmp1_);
#line 274 "../src/Widgets/CameraView.vala"
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
#line 275 "../src/Widgets/CameraView.vala"
	_tmp2_ = self->priv->color_balance;
#line 275 "../src/Widgets/CameraView.vala"
	g_value_init (&_tmp3_, G_TYPE_DOUBLE);
#line 275 "../src/Widgets/CameraView.vala"
	g_value_set_double (&_tmp3_, contrast);
#line 275 "../src/Widgets/CameraView.vala"
	g_object_set_property ((GObject*) _tmp2_, "contrast", &_tmp3_);
#line 275 "../src/Widgets/CameraView.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 1063 "CameraView.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 278 "../src/Widgets/CameraView.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 278 "../src/Widgets/CameraView.vala"
	return _data6_;
#line 1073 "CameraView.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 278 "../src/Widgets/CameraView.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 1083 "CameraView.c"
		CameraWidgetsCameraView* self;
#line 278 "../src/Widgets/CameraView.vala"
		self = _data6_->self;
#line 278 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (_data6_->picture_pipeline);
#line 278 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (self);
#line 278 "../src/Widgets/CameraView.vala"
		g_slice_free (Block6Data, _data6_);
#line 1093 "CameraView.c"
	}
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 1125 "CameraView.c"
}

static gboolean
___lambda7_ (Block6Data* _data6_)
{
	CameraWidgetsCameraView* self;
	GstPipeline* _tmp0_;
	GstDevice* _tmp1_;
	gboolean result;
#line 311 "../src/Widgets/CameraView.vala"
	self = _data6_->self;
#line 312 "../src/Widgets/CameraView.vala"
	_tmp0_ = _data6_->picture_pipeline;
#line 312 "../src/Widgets/CameraView.vala"
	gst_element_set_state ((GstElement*) _tmp0_, GST_STATE_NULL);
#line 313 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_play_shutter_sound ();
#line 314 "../src/Widgets/CameraView.vala"
	_tmp1_ = self->priv->current_device;
#line 314 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_create_pipeline (self, _tmp1_);
#line 316 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_set_recording (self, FALSE);
#line 317 "../src/Widgets/CameraView.vala"
	result = G_SOURCE_REMOVE;
#line 317 "../src/Widgets/CameraView.vala"
	return result;
#line 1153 "CameraView.c"
}

static gboolean
____lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda7_ (self);
#line 311 "../src/Widgets/CameraView.vala"
	return result;
#line 1163 "CameraView.c"
}

static GstPadProbeReturn
__lambda6_ (Block6Data* _data6_,
            GstPad* pad,
            GstPadProbeInfo* info)
{
	CameraWidgetsCameraView* self;
	GstEvent* _tmp0_;
	GstPadProbeReturn result;
#line 309 "../src/Widgets/CameraView.vala"
	self = _data6_->self;
#line 309 "../src/Widgets/CameraView.vala"
	g_return_val_if_fail (pad != NULL, 0);
#line 309 "../src/Widgets/CameraView.vala"
	g_return_val_if_fail (info != NULL, 0);
#line 310 "../src/Widgets/CameraView.vala"
	_tmp0_ = gst_pad_probe_info_get_event (info);
#line 310 "../src/Widgets/CameraView.vala"
	if (_tmp0_->type == GST_EVENT_EOS) {
#line 311 "../src/Widgets/CameraView.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda7__gsource_func, block6_data_ref (_data6_), block6_data_unref);
#line 320 "../src/Widgets/CameraView.vala"
		result = GST_PAD_PROBE_REMOVE;
#line 320 "../src/Widgets/CameraView.vala"
		return result;
#line 1190 "CameraView.c"
	}
#line 323 "../src/Widgets/CameraView.vala"
	result = GST_PAD_PROBE_PASS;
#line 323 "../src/Widgets/CameraView.vala"
	return result;
#line 1196 "CameraView.c"
}

static GstPadProbeReturn
___lambda6__gst_pad_probe_callback (GstPad* pad,
                                    GstPadProbeInfo* info,
                                    gpointer self)
{
	GstPadProbeReturn result;
	result = __lambda6_ (self, pad, info);
#line 309 "../src/Widgets/CameraView.vala"
	return result;
#line 1208 "CameraView.c"
}

void
camera_widgets_camera_view_take_photo (CameraWidgetsCameraView* self)
{
	Block6Data* _data6_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GstPipeline* _tmp3_;
	GstPipeline* _tmp4_;
	GstElement* preview_video_src = NULL;
	GstPipeline* _tmp5_;
	GstElement* _tmp6_;
	gchar* device_path = NULL;
	GstElement* _tmp7_;
	gchar* _tmp8_ = NULL;
	GValue brightness_value = {0};
	GValue _tmp9_ = {0};
	GstColorBalance* _tmp10_;
	GValue contrast_value = {0};
	GValue _tmp11_ = {0};
	GstColorBalance* _tmp12_;
	GstElement* filesink = NULL;
	GstPipeline* _tmp47_;
	GstElement* _tmp48_;
	GstElement* _tmp49_;
	GstPad* _tmp50_;
	GstPad* _tmp51_;
	GstPipeline* _tmp52_;
	GstPipeline* _tmp53_;
	GstPipeline* _tmp54_;
	GError* _inner_error0_ = NULL;
#line 278 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/Widgets/CameraView.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 278 "../src/Widgets/CameraView.vala"
	_data6_->_ref_count_ = 1;
#line 278 "../src/Widgets/CameraView.vala"
	_data6_->self = g_object_ref (self);
#line 279 "../src/Widgets/CameraView.vala"
	_tmp1_ = self->priv->_recording;
#line 279 "../src/Widgets/CameraView.vala"
	if (_tmp1_) {
#line 279 "../src/Widgets/CameraView.vala"
		_tmp0_ = TRUE;
#line 1255 "CameraView.c"
	} else {
		GstPipeline* _tmp2_;
#line 279 "../src/Widgets/CameraView.vala"
		_tmp2_ = self->priv->pipeline;
#line 279 "../src/Widgets/CameraView.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1262 "CameraView.c"
	}
#line 279 "../src/Widgets/CameraView.vala"
	if (_tmp0_) {
#line 280 "../src/Widgets/CameraView.vala"
		block6_data_unref (_data6_);
#line 280 "../src/Widgets/CameraView.vala"
		_data6_ = NULL;
#line 280 "../src/Widgets/CameraView.vala"
		return;
#line 1272 "CameraView.c"
	}
#line 283 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_set_recording (self, TRUE);
#line 284 "../src/Widgets/CameraView.vala"
	_tmp3_ = self->priv->pipeline;
#line 284 "../src/Widgets/CameraView.vala"
	gst_element_set_state ((GstElement*) _tmp3_, GST_STATE_NULL);
#line 285 "../src/Widgets/CameraView.vala"
	_tmp4_ = self->priv->pipeline;
#line 285 "../src/Widgets/CameraView.vala"
	gst_bin_sync_children_states ((GstBin*) _tmp4_);
#line 287 "../src/Widgets/CameraView.vala"
	_tmp5_ = self->priv->pipeline;
#line 287 "../src/Widgets/CameraView.vala"
	_tmp6_ = gst_bin_get_by_name ((GstBin*) _tmp5_, CAMERA_WIDGETS_CAMERA_VIEW_VIDEO_SRC_NAME);
#line 287 "../src/Widgets/CameraView.vala"
	preview_video_src = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gst_element_get_type (), GstElement);
#line 289 "../src/Widgets/CameraView.vala"
	_tmp7_ = preview_video_src;
#line 289 "../src/Widgets/CameraView.vala"
	g_object_get ((GObject*) _tmp7_, "device", &_tmp8_, NULL);
#line 289 "../src/Widgets/CameraView.vala"
	_g_free0 (device_path);
#line 289 "../src/Widgets/CameraView.vala"
	device_path = _tmp8_;
#line 290 "../src/Widgets/CameraView.vala"
	g_value_init (&_tmp9_, G_TYPE_DOUBLE);
#line 290 "../src/Widgets/CameraView.vala"
	brightness_value = _tmp9_;
#line 291 "../src/Widgets/CameraView.vala"
	_tmp10_ = self->priv->color_balance;
#line 291 "../src/Widgets/CameraView.vala"
	g_object_get_property ((GObject*) _tmp10_, "brightness", &brightness_value);
#line 292 "../src/Widgets/CameraView.vala"
	g_value_init (&_tmp11_, G_TYPE_DOUBLE);
#line 292 "../src/Widgets/CameraView.vala"
	contrast_value = _tmp11_;
#line 293 "../src/Widgets/CameraView.vala"
	_tmp12_ = self->priv->color_balance;
#line 293 "../src/Widgets/CameraView.vala"
	g_object_get_property ((GObject*) _tmp12_, "contrast", &contrast_value);
#line 1314 "CameraView.c"
	{
		const gchar* _tmp13_ = NULL;
		gboolean _tmp14_;
		gboolean _tmp15_;
		GstElement* _tmp16_ = NULL;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		GstElement* _tmp42_;
		GstElement* _tmp43_;
		GstPipeline* _tmp44_;
#line 299 "../src/Widgets/CameraView.vala"
		_tmp14_ = camera_widgets_camera_view_get_horizontal_flip (self);
#line 299 "../src/Widgets/CameraView.vala"
		_tmp15_ = _tmp14_;
#line 299 "../src/Widgets/CameraView.vala"
		if (_tmp15_) {
#line 299 "../src/Widgets/CameraView.vala"
			_tmp13_ = "horizontal-flip";
#line 1356 "CameraView.c"
		} else {
#line 299 "../src/Widgets/CameraView.vala"
			_tmp13_ = "none";
#line 1360 "CameraView.c"
		}
#line 296 "../src/Widgets/CameraView.vala"
		_tmp17_ = device_path;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp18_ = g_strdup_printf ("v4l2src device=%s name=%s num-buffers=1 !", _tmp17_, CAMERA_WIDGETS_CAMERA_VIEW_VIDEO_SRC_NAME);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp19_ = _tmp18_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp20_ = g_strdup_printf ("videoscale ! video/x-raw, width=%d, height=%d !", self->priv->picture_width, self->priv->picture_height);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp21_ = _tmp20_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp22_ = g_strconcat (_tmp19_, _tmp21_, NULL);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp23_ = _tmp22_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp24_ = g_strdup_printf ("videoflip method=%s !", _tmp13_);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp25_ = _tmp24_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp26_ = g_strconcat (_tmp23_, _tmp25_, NULL);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp27_ = _tmp26_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp28_ = double_to_string (g_value_get_double (&brightness_value));
#line 296 "../src/Widgets/CameraView.vala"
		_tmp29_ = _tmp28_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp30_ = double_to_string (g_value_get_double (&contrast_value));
#line 296 "../src/Widgets/CameraView.vala"
		_tmp31_ = _tmp30_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp32_ = g_strdup_printf ("videobalance brightness=%s contrast=%s !", _tmp29_, _tmp31_);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp33_ = _tmp32_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp34_ = g_strconcat (_tmp27_, _tmp33_, NULL);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp35_ = _tmp34_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp36_ = camera_utils_get_new_media_filename (CAMERA_UTILS_ACTION_TYPE_PHOTO);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp37_ = _tmp36_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp38_ = g_strdup_printf ("jpegenc ! filesink location=%s name=filesink", _tmp37_);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp39_ = _tmp38_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp40_ = g_strconcat (_tmp35_, _tmp39_, NULL);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp41_ = _tmp40_;
#line 296 "../src/Widgets/CameraView.vala"
		_tmp42_ = gst_parse_launch_full (_tmp41_, NULL, GST_PARSE_FLAG_NONE, &_inner_error0_);
#line 296 "../src/Widgets/CameraView.vala"
		if (_tmp42_ != NULL) {
#line 296 "../src/Widgets/CameraView.vala"
			g_object_ref_sink (_tmp42_);
#line 1418 "CameraView.c"
		}
#line 296 "../src/Widgets/CameraView.vala"
		_tmp43_ = _tmp42_;
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp41_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp39_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp37_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp35_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp33_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp31_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp29_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp27_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp25_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp23_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp21_);
#line 296 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp19_);
#line 296 "../src/Widgets/CameraView.vala"
		_tmp16_ = _tmp43_;
#line 296 "../src/Widgets/CameraView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1450 "CameraView.c"
			goto __catch0_g_error;
		}
#line 296 "../src/Widgets/CameraView.vala"
		_tmp44_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gst_pipeline_get_type (), GstPipeline));
#line 296 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (_data6_->picture_pipeline);
#line 296 "../src/Widgets/CameraView.vala"
		_data6_->picture_pipeline = _tmp44_;
#line 295 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (_tmp16_);
#line 1461 "CameraView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp45_;
		const gchar* _tmp46_;
#line 295 "../src/Widgets/CameraView.vala"
		e = _inner_error0_;
#line 295 "../src/Widgets/CameraView.vala"
		_inner_error0_ = NULL;
#line 304 "../src/Widgets/CameraView.vala"
		_tmp45_ = e;
#line 304 "../src/Widgets/CameraView.vala"
		_tmp46_ = _tmp45_->message;
#line 304 "../src/Widgets/CameraView.vala"
		g_warning ("CameraView.vala:304: Could not make picture pipeline for photo - %s", _tmp46_);
#line 305 "../src/Widgets/CameraView.vala"
		_g_error_free0 (e);
#line 305 "../src/Widgets/CameraView.vala"
		G_IS_VALUE (&contrast_value) ? (g_value_unset (&contrast_value), NULL) : NULL;
#line 305 "../src/Widgets/CameraView.vala"
		G_IS_VALUE (&brightness_value) ? (g_value_unset (&brightness_value), NULL) : NULL;
#line 305 "../src/Widgets/CameraView.vala"
		_g_free0 (device_path);
#line 305 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (preview_video_src);
#line 305 "../src/Widgets/CameraView.vala"
		block6_data_unref (_data6_);
#line 305 "../src/Widgets/CameraView.vala"
		_data6_ = NULL;
#line 305 "../src/Widgets/CameraView.vala"
		return;
#line 1495 "CameraView.c"
	}
	__finally0:
#line 295 "../src/Widgets/CameraView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 295 "../src/Widgets/CameraView.vala"
		G_IS_VALUE (&contrast_value) ? (g_value_unset (&contrast_value), NULL) : NULL;
#line 295 "../src/Widgets/CameraView.vala"
		G_IS_VALUE (&brightness_value) ? (g_value_unset (&brightness_value), NULL) : NULL;
#line 295 "../src/Widgets/CameraView.vala"
		_g_free0 (device_path);
#line 295 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (preview_video_src);
#line 295 "../src/Widgets/CameraView.vala"
		block6_data_unref (_data6_);
#line 295 "../src/Widgets/CameraView.vala"
		_data6_ = NULL;
#line 295 "../src/Widgets/CameraView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 295 "../src/Widgets/CameraView.vala"
		g_clear_error (&_inner_error0_);
#line 295 "../src/Widgets/CameraView.vala"
		return;
#line 1518 "CameraView.c"
	}
#line 308 "../src/Widgets/CameraView.vala"
	_tmp47_ = _data6_->picture_pipeline;
#line 308 "../src/Widgets/CameraView.vala"
	_tmp48_ = gst_bin_get_by_name ((GstBin*) _tmp47_, "filesink");
#line 308 "../src/Widgets/CameraView.vala"
	filesink = _tmp48_;
#line 309 "../src/Widgets/CameraView.vala"
	_tmp49_ = filesink;
#line 309 "../src/Widgets/CameraView.vala"
	_tmp50_ = gst_element_get_static_pad (_tmp49_, "sink");
#line 309 "../src/Widgets/CameraView.vala"
	_tmp51_ = _tmp50_;
#line 309 "../src/Widgets/CameraView.vala"
	gst_pad_add_probe (_tmp51_, GST_PAD_PROBE_TYPE_EVENT_DOWNSTREAM, ___lambda6__gst_pad_probe_callback, block6_data_ref (_data6_), block6_data_unref);
#line 309 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (_tmp51_);
#line 326 "../src/Widgets/CameraView.vala"
	_tmp52_ = _data6_->picture_pipeline;
#line 326 "../src/Widgets/CameraView.vala"
	gst_element_set_state ((GstElement*) _tmp52_, GST_STATE_PLAYING);
#line 327 "../src/Widgets/CameraView.vala"
	_tmp53_ = _data6_->picture_pipeline;
#line 327 "../src/Widgets/CameraView.vala"
	gst_bin_sync_children_states ((GstBin*) _tmp53_);
#line 329 "../src/Widgets/CameraView.vala"
	_tmp54_ = self->priv->pipeline;
#line 329 "../src/Widgets/CameraView.vala"
	GST_DEBUG_BIN_TO_DOT_FILE ((GstBin*) _tmp54_, GST_DEBUG_GRAPH_SHOW_VERBOSE, "snapshot");
#line 278 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (filesink);
#line 278 "../src/Widgets/CameraView.vala"
	G_IS_VALUE (&contrast_value) ? (g_value_unset (&contrast_value), NULL) : NULL;
#line 278 "../src/Widgets/CameraView.vala"
	G_IS_VALUE (&brightness_value) ? (g_value_unset (&brightness_value), NULL) : NULL;
#line 278 "../src/Widgets/CameraView.vala"
	_g_free0 (device_path);
#line 278 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (preview_video_src);
#line 278 "../src/Widgets/CameraView.vala"
	block6_data_unref (_data6_);
#line 278 "../src/Widgets/CameraView.vala"
	_data6_ = NULL;
#line 1562 "CameraView.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 344 "../src/Widgets/CameraView.vala"
	if ((*length) == (*size)) {
#line 344 "../src/Widgets/CameraView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 344 "../src/Widgets/CameraView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1577 "CameraView.c"
	}
#line 344 "../src/Widgets/CameraView.vala"
	(*array)[(*length)++] = value;
#line 344 "../src/Widgets/CameraView.vala"
	(*array)[*length] = NULL;
#line 1583 "CameraView.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 349 "../src/Widgets/CameraView.vala"
	if ((*length) == (*size)) {
#line 349 "../src/Widgets/CameraView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 349 "../src/Widgets/CameraView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1598 "CameraView.c"
	}
#line 349 "../src/Widgets/CameraView.vala"
	(*array)[(*length)++] = value;
#line 349 "../src/Widgets/CameraView.vala"
	(*array)[*length] = NULL;
#line 1604 "CameraView.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 354 "../src/Widgets/CameraView.vala"
	if ((*length) == (*size)) {
#line 354 "../src/Widgets/CameraView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 354 "../src/Widgets/CameraView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1619 "CameraView.c"
	}
#line 354 "../src/Widgets/CameraView.vala"
	(*array)[(*length)++] = value;
#line 354 "../src/Widgets/CameraView.vala"
	(*array)[*length] = NULL;
#line 1625 "CameraView.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 359 "../src/Widgets/CameraView.vala"
	if ((*length) == (*size)) {
#line 359 "../src/Widgets/CameraView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 359 "../src/Widgets/CameraView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1640 "CameraView.c"
	}
#line 359 "../src/Widgets/CameraView.vala"
	(*array)[(*length)++] = value;
#line 359 "../src/Widgets/CameraView.vala"
	(*array)[*length] = NULL;
#line 1646 "CameraView.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 366 "../src/Widgets/CameraView.vala"
	if ((*length) == (*size)) {
#line 366 "../src/Widgets/CameraView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 366 "../src/Widgets/CameraView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1661 "CameraView.c"
	}
#line 366 "../src/Widgets/CameraView.vala"
	(*array)[(*length)++] = value;
#line 366 "../src/Widgets/CameraView.vala"
	(*array)[*length] = NULL;
#line 1667 "CameraView.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 371 "../src/Widgets/CameraView.vala"
	if ((*length) == (*size)) {
#line 371 "../src/Widgets/CameraView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 371 "../src/Widgets/CameraView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1682 "CameraView.c"
	}
#line 371 "../src/Widgets/CameraView.vala"
	(*array)[(*length)++] = value;
#line 371 "../src/Widgets/CameraView.vala"
	(*array)[*length] = NULL;
#line 1688 "CameraView.c"
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 376 "../src/Widgets/CameraView.vala"
	if ((*length) == (*size)) {
#line 376 "../src/Widgets/CameraView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 376 "../src/Widgets/CameraView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1703 "CameraView.c"
	}
#line 376 "../src/Widgets/CameraView.vala"
	(*array)[(*length)++] = value;
#line 376 "../src/Widgets/CameraView.vala"
	(*array)[*length] = NULL;
#line 1709 "CameraView.c"
}

static void
___lambda8_ (CameraWidgetsCameraView* self,
             GstInstallPluginsReturn _result_)
{
}

static void
____lambda8__gst_install_plugins_result_func (GstInstallPluginsReturn _result_,
                                              gpointer self)
{
#line 382 "../src/Widgets/CameraView.vala"
	___lambda8_ ((CameraWidgetsCameraView*) self, _result_);
#line 382 "../src/Widgets/CameraView.vala"
	g_object_unref (self);
#line 1726 "CameraView.c"
}

void
camera_widgets_camera_view_start_recording (CameraWidgetsCameraView* self)
{
	gboolean _tmp0_;
	GstBin* _tmp1_;
	gchar** missing_messages = NULL;
	gchar** _tmp2_;
	gint missing_messages_length1;
	gint _missing_messages_size_;
	GstElement* queue = NULL;
	GstElement* _tmp3_;
	GstElement* videoconvert = NULL;
	GstElement* _tmp4_;
	GstElement* _tmp5_;
	GstElement* encoder = NULL;
	GstElement* _tmp7_;
	GstElement* _tmp8_;
	GstElement* muxer = NULL;
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	GstElement* alsasrc = NULL;
	GstElement* _tmp13_;
	GstElement* _tmp14_;
	GstElement* audio_queue = NULL;
	GstElement* _tmp16_;
	GstElement* audio_convert = NULL;
	GstElement* _tmp17_;
	GstElement* _tmp18_;
	GstElement* audio_vorbis = NULL;
	GstElement* _tmp20_;
	GstElement* _tmp21_;
	GstElement* filesink = NULL;
	GstElement* _tmp23_;
	GstElement* _tmp24_;
	gchar** _tmp29_;
	gint _tmp29__length1;
	GstBin* _tmp31_;
	GstElement* _tmp32_;
	GstElement* _tmp33_;
	GstElement* _tmp34_;
	GstElement* _tmp35_;
	GstElement* _tmp36_;
	GstElement* _tmp37_;
	GstElement* _tmp38_;
	GstElement* _tmp39_;
	GstElement* _tmp40_;
	GstElement* _tmp41_;
	GstBin* _tmp42_;
	GstElement* _tmp43_;
	GstElement* _tmp44_;
	GstElement* _tmp45_;
	GstElement* _tmp46_;
	GstElement* _tmp47_;
	GstElement* _tmp48_;
	GstElement* _tmp49_;
	GstElement* _tmp50_;
	GstElement* _tmp51_;
	GstGhostPad* ghostpad = NULL;
	GstElement* _tmp52_;
	GstPad* _tmp53_;
	GstPad* _tmp54_;
	GstGhostPad* _tmp55_;
	GstGhostPad* _tmp56_;
	GstBin* _tmp57_;
	GstGhostPad* _tmp58_;
	GstPipeline* _tmp59_;
	GstPipeline* _tmp60_;
	GstBin* _tmp61_;
	GstBin* _tmp62_;
	GstElement* _tmp63_;
	GstBin* _tmp64_;
	GstPipeline* _tmp65_;
	GstPipeline* _tmp66_;
#line 332 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/Widgets/CameraView.vala"
	_tmp0_ = self->priv->_recording;
#line 333 "../src/Widgets/CameraView.vala"
	if (_tmp0_) {
#line 334 "../src/Widgets/CameraView.vala"
		return;
#line 1810 "CameraView.c"
	}
#line 337 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_set_recording (self, TRUE);
#line 338 "../src/Widgets/CameraView.vala"
	_tmp1_ = (GstBin*) gst_bin_new (NULL);
#line 338 "../src/Widgets/CameraView.vala"
	g_object_ref_sink (_tmp1_);
#line 338 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->record_bin);
#line 338 "../src/Widgets/CameraView.vala"
	self->priv->record_bin = _tmp1_;
#line 340 "../src/Widgets/CameraView.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 340 "../src/Widgets/CameraView.vala"
	missing_messages = _tmp2_;
#line 340 "../src/Widgets/CameraView.vala"
	missing_messages_length1 = 0;
#line 340 "../src/Widgets/CameraView.vala"
	_missing_messages_size_ = missing_messages_length1;
#line 341 "../src/Widgets/CameraView.vala"
	_tmp3_ = gst_element_factory_make ("queue", NULL);
#line 341 "../src/Widgets/CameraView.vala"
	if (_tmp3_ != NULL) {
#line 341 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp3_);
#line 1836 "CameraView.c"
	}
#line 341 "../src/Widgets/CameraView.vala"
	queue = _tmp3_;
#line 342 "../src/Widgets/CameraView.vala"
	_tmp4_ = gst_element_factory_make ("videoconvert", NULL);
#line 342 "../src/Widgets/CameraView.vala"
	if (_tmp4_ != NULL) {
#line 342 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp4_);
#line 1846 "CameraView.c"
	}
#line 342 "../src/Widgets/CameraView.vala"
	videoconvert = _tmp4_;
#line 343 "../src/Widgets/CameraView.vala"
	_tmp5_ = videoconvert;
#line 343 "../src/Widgets/CameraView.vala"
	if (_tmp5_ == NULL) {
#line 1854 "CameraView.c"
		gchar* _tmp6_;
#line 344 "../src/Widgets/CameraView.vala"
		_tmp6_ = gst_missing_element_installer_detail_new ("videoconvert");
#line 344 "../src/Widgets/CameraView.vala"
		_vala_array_add1 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp6_);
#line 1860 "CameraView.c"
	}
#line 347 "../src/Widgets/CameraView.vala"
	_tmp7_ = gst_element_factory_make ("vp8enc", NULL);
#line 347 "../src/Widgets/CameraView.vala"
	if (_tmp7_ != NULL) {
#line 347 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp7_);
#line 1868 "CameraView.c"
	}
#line 347 "../src/Widgets/CameraView.vala"
	encoder = _tmp7_;
#line 348 "../src/Widgets/CameraView.vala"
	_tmp8_ = encoder;
#line 348 "../src/Widgets/CameraView.vala"
	if (_tmp8_ == NULL) {
#line 1876 "CameraView.c"
		gchar* _tmp9_;
#line 349 "../src/Widgets/CameraView.vala"
		_tmp9_ = gst_missing_element_installer_detail_new ("vp8enc");
#line 349 "../src/Widgets/CameraView.vala"
		_vala_array_add2 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp9_);
#line 1882 "CameraView.c"
	}
#line 352 "../src/Widgets/CameraView.vala"
	_tmp10_ = gst_element_factory_make ("webmmux", NULL);
#line 352 "../src/Widgets/CameraView.vala"
	if (_tmp10_ != NULL) {
#line 352 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp10_);
#line 1890 "CameraView.c"
	}
#line 352 "../src/Widgets/CameraView.vala"
	muxer = _tmp10_;
#line 353 "../src/Widgets/CameraView.vala"
	_tmp11_ = muxer;
#line 353 "../src/Widgets/CameraView.vala"
	if (_tmp11_ == NULL) {
#line 1898 "CameraView.c"
		gchar* _tmp12_;
#line 354 "../src/Widgets/CameraView.vala"
		_tmp12_ = gst_missing_element_installer_detail_new ("webmmux");
#line 354 "../src/Widgets/CameraView.vala"
		_vala_array_add3 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp12_);
#line 1904 "CameraView.c"
	}
#line 357 "../src/Widgets/CameraView.vala"
	_tmp13_ = gst_element_factory_make ("alsasrc", NULL);
#line 357 "../src/Widgets/CameraView.vala"
	if (_tmp13_ != NULL) {
#line 357 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp13_);
#line 1912 "CameraView.c"
	}
#line 357 "../src/Widgets/CameraView.vala"
	alsasrc = _tmp13_;
#line 358 "../src/Widgets/CameraView.vala"
	_tmp14_ = alsasrc;
#line 358 "../src/Widgets/CameraView.vala"
	if (_tmp14_ == NULL) {
#line 1920 "CameraView.c"
		gchar* _tmp15_;
#line 359 "../src/Widgets/CameraView.vala"
		_tmp15_ = gst_missing_element_installer_detail_new ("alsasrc");
#line 359 "../src/Widgets/CameraView.vala"
		_vala_array_add4 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp15_);
#line 1926 "CameraView.c"
	}
#line 362 "../src/Widgets/CameraView.vala"
	_tmp16_ = gst_element_factory_make ("queue", NULL);
#line 362 "../src/Widgets/CameraView.vala"
	if (_tmp16_ != NULL) {
#line 362 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp16_);
#line 1934 "CameraView.c"
	}
#line 362 "../src/Widgets/CameraView.vala"
	audio_queue = _tmp16_;
#line 364 "../src/Widgets/CameraView.vala"
	_tmp17_ = gst_element_factory_make ("audioconvert", NULL);
#line 364 "../src/Widgets/CameraView.vala"
	if (_tmp17_ != NULL) {
#line 364 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp17_);
#line 1944 "CameraView.c"
	}
#line 364 "../src/Widgets/CameraView.vala"
	audio_convert = _tmp17_;
#line 365 "../src/Widgets/CameraView.vala"
	_tmp18_ = audio_convert;
#line 365 "../src/Widgets/CameraView.vala"
	if (_tmp18_ == NULL) {
#line 1952 "CameraView.c"
		gchar* _tmp19_;
#line 366 "../src/Widgets/CameraView.vala"
		_tmp19_ = gst_missing_element_installer_detail_new ("audioconvert");
#line 366 "../src/Widgets/CameraView.vala"
		_vala_array_add5 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp19_);
#line 1958 "CameraView.c"
	}
#line 369 "../src/Widgets/CameraView.vala"
	_tmp20_ = gst_element_factory_make ("vorbisenc", NULL);
#line 369 "../src/Widgets/CameraView.vala"
	if (_tmp20_ != NULL) {
#line 369 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp20_);
#line 1966 "CameraView.c"
	}
#line 369 "../src/Widgets/CameraView.vala"
	audio_vorbis = _tmp20_;
#line 370 "../src/Widgets/CameraView.vala"
	_tmp21_ = audio_vorbis;
#line 370 "../src/Widgets/CameraView.vala"
	if (_tmp21_ == NULL) {
#line 1974 "CameraView.c"
		gchar* _tmp22_;
#line 371 "../src/Widgets/CameraView.vala"
		_tmp22_ = gst_missing_element_installer_detail_new ("vorbisenc");
#line 371 "../src/Widgets/CameraView.vala"
		_vala_array_add6 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp22_);
#line 1980 "CameraView.c"
	}
#line 374 "../src/Widgets/CameraView.vala"
	_tmp23_ = gst_element_factory_make ("filesink", "filesink");
#line 374 "../src/Widgets/CameraView.vala"
	if (_tmp23_ != NULL) {
#line 374 "../src/Widgets/CameraView.vala"
		g_object_ref_sink (_tmp23_);
#line 1988 "CameraView.c"
	}
#line 374 "../src/Widgets/CameraView.vala"
	filesink = _tmp23_;
#line 375 "../src/Widgets/CameraView.vala"
	_tmp24_ = filesink;
#line 375 "../src/Widgets/CameraView.vala"
	if (_tmp24_ == NULL) {
#line 1996 "CameraView.c"
		gchar* _tmp25_;
#line 376 "../src/Widgets/CameraView.vala"
		_tmp25_ = gst_missing_element_installer_detail_new ("filesink");
#line 376 "../src/Widgets/CameraView.vala"
		_vala_array_add7 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp25_);
#line 2002 "CameraView.c"
	} else {
		GstElement* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
#line 378 "../src/Widgets/CameraView.vala"
		_tmp26_ = filesink;
#line 378 "../src/Widgets/CameraView.vala"
		_tmp27_ = camera_utils_get_new_media_filename (CAMERA_UTILS_ACTION_TYPE_VIDEO);
#line 378 "../src/Widgets/CameraView.vala"
		_tmp28_ = _tmp27_;
#line 378 "../src/Widgets/CameraView.vala"
		g_object_set ((GObject*) _tmp26_, "location", _tmp28_, NULL);
#line 378 "../src/Widgets/CameraView.vala"
		_g_free0 (_tmp28_);
#line 2017 "CameraView.c"
	}
#line 381 "../src/Widgets/CameraView.vala"
	_tmp29_ = missing_messages;
#line 381 "../src/Widgets/CameraView.vala"
	_tmp29__length1 = missing_messages_length1;
#line 381 "../src/Widgets/CameraView.vala"
	if (_tmp29__length1 > 0) {
#line 2025 "CameraView.c"
		gchar** _tmp30_;
		gint _tmp30__length1;
#line 382 "../src/Widgets/CameraView.vala"
		_tmp30_ = missing_messages;
#line 382 "../src/Widgets/CameraView.vala"
		_tmp30__length1 = missing_messages_length1;
#line 382 "../src/Widgets/CameraView.vala"
		gst_install_plugins_async (_tmp30_, NULL, ____lambda8__gst_install_plugins_result_func, g_object_ref (self));
#line 383 "../src/Widgets/CameraView.vala"
		camera_widgets_camera_view_set_recording (self, FALSE);
#line 384 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (filesink);
#line 384 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (audio_vorbis);
#line 384 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (audio_convert);
#line 384 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (audio_queue);
#line 384 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (alsasrc);
#line 384 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (muxer);
#line 384 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (encoder);
#line 384 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (videoconvert);
#line 384 "../src/Widgets/CameraView.vala"
		_g_object_unref0 (queue);
#line 384 "../src/Widgets/CameraView.vala"
		missing_messages = (_vala_array_free (missing_messages, missing_messages_length1, (GDestroyNotify) g_free), NULL);
#line 384 "../src/Widgets/CameraView.vala"
		return;
#line 2058 "CameraView.c"
	}
#line 387 "../src/Widgets/CameraView.vala"
	_tmp31_ = self->priv->record_bin;
#line 387 "../src/Widgets/CameraView.vala"
	_tmp32_ = queue;
#line 387 "../src/Widgets/CameraView.vala"
	_tmp33_ = videoconvert;
#line 387 "../src/Widgets/CameraView.vala"
	_tmp34_ = encoder;
#line 387 "../src/Widgets/CameraView.vala"
	_tmp35_ = muxer;
#line 387 "../src/Widgets/CameraView.vala"
	_tmp36_ = filesink;
#line 387 "../src/Widgets/CameraView.vala"
	gst_bin_add_many (_tmp31_, _tmp32_, _tmp33_, _tmp34_, _tmp35_, _tmp36_, NULL);
#line 388 "../src/Widgets/CameraView.vala"
	_tmp37_ = queue;
#line 388 "../src/Widgets/CameraView.vala"
	_tmp38_ = videoconvert;
#line 388 "../src/Widgets/CameraView.vala"
	_tmp39_ = encoder;
#line 388 "../src/Widgets/CameraView.vala"
	_tmp40_ = muxer;
#line 388 "../src/Widgets/CameraView.vala"
	_tmp41_ = filesink;
#line 388 "../src/Widgets/CameraView.vala"
	gst_element_link_many (_tmp37_, _tmp38_, _tmp39_, _tmp40_, _tmp41_, NULL);
#line 390 "../src/Widgets/CameraView.vala"
	_tmp42_ = self->priv->record_bin;
#line 390 "../src/Widgets/CameraView.vala"
	_tmp43_ = alsasrc;
#line 390 "../src/Widgets/CameraView.vala"
	_tmp44_ = audio_queue;
#line 390 "../src/Widgets/CameraView.vala"
	_tmp45_ = audio_convert;
#line 390 "../src/Widgets/CameraView.vala"
	_tmp46_ = audio_vorbis;
#line 390 "../src/Widgets/CameraView.vala"
	gst_bin_add_many (_tmp42_, _tmp43_, _tmp44_, _tmp45_, _tmp46_, NULL);
#line 391 "../src/Widgets/CameraView.vala"
	_tmp47_ = alsasrc;
#line 391 "../src/Widgets/CameraView.vala"
	_tmp48_ = audio_queue;
#line 391 "../src/Widgets/CameraView.vala"
	_tmp49_ = audio_convert;
#line 391 "../src/Widgets/CameraView.vala"
	_tmp50_ = audio_vorbis;
#line 391 "../src/Widgets/CameraView.vala"
	_tmp51_ = muxer;
#line 391 "../src/Widgets/CameraView.vala"
	gst_element_link_many (_tmp47_, _tmp48_, _tmp49_, _tmp50_, _tmp51_, NULL);
#line 393 "../src/Widgets/CameraView.vala"
	_tmp52_ = queue;
#line 393 "../src/Widgets/CameraView.vala"
	_tmp53_ = gst_element_get_static_pad (_tmp52_, "sink");
#line 393 "../src/Widgets/CameraView.vala"
	_tmp54_ = _tmp53_;
#line 393 "../src/Widgets/CameraView.vala"
	_tmp55_ = (GstGhostPad*) gst_ghost_pad_new (NULL, _tmp54_);
#line 393 "../src/Widgets/CameraView.vala"
	g_object_ref_sink (_tmp55_);
#line 393 "../src/Widgets/CameraView.vala"
	_tmp56_ = _tmp55_;
#line 393 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (_tmp54_);
#line 393 "../src/Widgets/CameraView.vala"
	ghostpad = _tmp56_;
#line 394 "../src/Widgets/CameraView.vala"
	_tmp57_ = self->priv->record_bin;
#line 394 "../src/Widgets/CameraView.vala"
	_tmp58_ = ghostpad;
#line 394 "../src/Widgets/CameraView.vala"
	gst_element_add_pad ((GstElement*) _tmp57_, (GstPad*) _tmp58_);
#line 396 "../src/Widgets/CameraView.vala"
	_tmp59_ = self->priv->pipeline;
#line 396 "../src/Widgets/CameraView.vala"
	gst_element_set_state ((GstElement*) _tmp59_, GST_STATE_PAUSED);
#line 397 "../src/Widgets/CameraView.vala"
	_tmp60_ = self->priv->pipeline;
#line 397 "../src/Widgets/CameraView.vala"
	_tmp61_ = self->priv->record_bin;
#line 397 "../src/Widgets/CameraView.vala"
	gst_bin_add ((GstBin*) _tmp60_, (GstElement*) _tmp61_);
#line 398 "../src/Widgets/CameraView.vala"
	_tmp62_ = self->priv->record_bin;
#line 398 "../src/Widgets/CameraView.vala"
	gst_element_sync_state_with_parent ((GstElement*) _tmp62_);
#line 399 "../src/Widgets/CameraView.vala"
	_tmp63_ = self->priv->tee;
#line 399 "../src/Widgets/CameraView.vala"
	_tmp64_ = self->priv->record_bin;
#line 399 "../src/Widgets/CameraView.vala"
	gst_element_link (_tmp63_, (GstElement*) _tmp64_);
#line 400 "../src/Widgets/CameraView.vala"
	_tmp65_ = self->priv->pipeline;
#line 400 "../src/Widgets/CameraView.vala"
	gst_element_set_state ((GstElement*) _tmp65_, GST_STATE_PLAYING);
#line 401 "../src/Widgets/CameraView.vala"
	_tmp66_ = self->priv->pipeline;
#line 401 "../src/Widgets/CameraView.vala"
	GST_DEBUG_BIN_TO_DOT_FILE ((GstBin*) _tmp66_, GST_DEBUG_GRAPH_SHOW_VERBOSE, "recording");
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (ghostpad);
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (filesink);
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (audio_vorbis);
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (audio_convert);
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (audio_queue);
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (alsasrc);
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (muxer);
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (encoder);
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (videoconvert);
#line 332 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (queue);
#line 332 "../src/Widgets/CameraView.vala"
	missing_messages = (_vala_array_free (missing_messages, missing_messages_length1, (GDestroyNotify) g_free), NULL);
#line 2182 "CameraView.c"
}

void
camera_widgets_camera_view_stop_recording (CameraWidgetsCameraView* self)
{
	gboolean _tmp0_;
	GstPipeline* _tmp1_;
	GstElement* _tmp2_;
	GstBin* _tmp3_;
	GstElement* filesink = NULL;
	GstBin* _tmp4_;
	GstElement* _tmp5_;
	GstElement* _tmp6_;
	GstPipeline* _tmp12_;
	GstBin* _tmp13_;
	GstPipeline* _tmp14_;
	GstBin* _tmp15_;
	GstBin* _tmp16_;
#line 404 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 405 "../src/Widgets/CameraView.vala"
	_tmp0_ = self->priv->_recording;
#line 405 "../src/Widgets/CameraView.vala"
	if (!_tmp0_) {
#line 406 "../src/Widgets/CameraView.vala"
		return;
#line 2209 "CameraView.c"
	}
#line 409 "../src/Widgets/CameraView.vala"
	_tmp1_ = self->priv->pipeline;
#line 409 "../src/Widgets/CameraView.vala"
	gst_element_set_state ((GstElement*) _tmp1_, GST_STATE_PAUSED);
#line 410 "../src/Widgets/CameraView.vala"
	_tmp2_ = self->priv->tee;
#line 410 "../src/Widgets/CameraView.vala"
	_tmp3_ = self->priv->record_bin;
#line 410 "../src/Widgets/CameraView.vala"
	gst_element_unlink (_tmp2_, (GstElement*) _tmp3_);
#line 411 "../src/Widgets/CameraView.vala"
	_tmp4_ = self->priv->record_bin;
#line 411 "../src/Widgets/CameraView.vala"
	_tmp5_ = gst_bin_get_by_name (_tmp4_, "filesink");
#line 411 "../src/Widgets/CameraView.vala"
	filesink = _tmp5_;
#line 413 "../src/Widgets/CameraView.vala"
	_tmp6_ = filesink;
#line 413 "../src/Widgets/CameraView.vala"
	if (_tmp6_ != NULL) {
#line 2231 "CameraView.c"
		GValue locationval = {0};
		GValue _tmp7_ = {0};
		GstElement* _tmp8_;
		gchar* location = NULL;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
#line 414 "../src/Widgets/CameraView.vala"
		g_value_init (&_tmp7_, G_TYPE_STRING);
#line 414 "../src/Widgets/CameraView.vala"
		locationval = _tmp7_;
#line 415 "../src/Widgets/CameraView.vala"
		_tmp8_ = filesink;
#line 415 "../src/Widgets/CameraView.vala"
		g_object_get_property ((GObject*) _tmp8_, "location", &locationval);
#line 416 "../src/Widgets/CameraView.vala"
		_tmp9_ = g_value_get_string (&locationval);
#line 416 "../src/Widgets/CameraView.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 416 "../src/Widgets/CameraView.vala"
		location = _tmp10_;
#line 417 "../src/Widgets/CameraView.vala"
		_tmp11_ = location;
#line 417 "../src/Widgets/CameraView.vala"
		g_signal_emit (self, camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_FINISHED_SIGNAL], 0, _tmp11_);
#line 413 "../src/Widgets/CameraView.vala"
		_g_free0 (location);
#line 413 "../src/Widgets/CameraView.vala"
		G_IS_VALUE (&locationval) ? (g_value_unset (&locationval), NULL) : NULL;
#line 2261 "CameraView.c"
	}
#line 420 "../src/Widgets/CameraView.vala"
	_tmp12_ = self->priv->pipeline;
#line 420 "../src/Widgets/CameraView.vala"
	_tmp13_ = self->priv->record_bin;
#line 420 "../src/Widgets/CameraView.vala"
	gst_bin_remove ((GstBin*) _tmp12_, (GstElement*) _tmp13_);
#line 421 "../src/Widgets/CameraView.vala"
	_tmp14_ = self->priv->pipeline;
#line 421 "../src/Widgets/CameraView.vala"
	gst_element_set_state ((GstElement*) _tmp14_, GST_STATE_PLAYING);
#line 422 "../src/Widgets/CameraView.vala"
	_tmp15_ = self->priv->record_bin;
#line 422 "../src/Widgets/CameraView.vala"
	gst_element_set_state ((GstElement*) _tmp15_, GST_STATE_NULL);
#line 423 "../src/Widgets/CameraView.vala"
	_tmp16_ = self->priv->record_bin;
#line 423 "../src/Widgets/CameraView.vala"
	g_object_run_dispose ((GObject*) _tmp16_);
#line 424 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_set_recording (self, FALSE);
#line 404 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (filesink);
#line 2285 "CameraView.c"
}

static void
camera_widgets_camera_view_play_shutter_sound (void)
{
	ca_context* context = NULL;
	ca_proplist* props = NULL;
	ca_context* _tmp0_ = NULL;
	ca_proplist* _tmp1_ = NULL;
#line 431 "../src/Widgets/CameraView.vala"
	ca_context_create (&_tmp0_);
#line 431 "../src/Widgets/CameraView.vala"
	_ca_context_destroy0 (context);
#line 431 "../src/Widgets/CameraView.vala"
	context = _tmp0_;
#line 432 "../src/Widgets/CameraView.vala"
	ca_proplist_create (&_tmp1_);
#line 432 "../src/Widgets/CameraView.vala"
	_ca_proplist_destroy0 (props);
#line 432 "../src/Widgets/CameraView.vala"
	props = _tmp1_;
#line 434 "../src/Widgets/CameraView.vala"
	ca_proplist_sets (props, CA_PROP_EVENT_ID, "camera-shutter");
#line 435 "../src/Widgets/CameraView.vala"
	ca_proplist_sets (props, CA_PROP_EVENT_DESCRIPTION, _ ("Photo taken"));
#line 436 "../src/Widgets/CameraView.vala"
	ca_proplist_sets (props, CA_PROP_CANBERRA_CACHE_CONTROL, "permanent");
#line 437 "../src/Widgets/CameraView.vala"
	ca_proplist_sets (props, CA_PROP_MEDIA_ROLE, "event");
#line 439 "../src/Widgets/CameraView.vala"
	ca_context_play_full (context, (guint32) 0, props, NULL, NULL);
#line 427 "../src/Widgets/CameraView.vala"
	_ca_proplist_destroy0 (props);
#line 427 "../src/Widgets/CameraView.vala"
	_ca_context_destroy0 (context);
#line 2321 "CameraView.c"
}

CameraWidgetsCameraView*
camera_widgets_camera_view_construct (GType object_type)
{
	CameraWidgetsCameraView * self = NULL;
#line 23 "../src/Widgets/CameraView.vala"
	self = (CameraWidgetsCameraView*) g_object_new (object_type, NULL);
#line 23 "../src/Widgets/CameraView.vala"
	return self;
#line 2332 "CameraView.c"
}

CameraWidgetsCameraView*
camera_widgets_camera_view_new (void)
{
#line 23 "../src/Widgets/CameraView.vala"
	return camera_widgets_camera_view_construct (CAMERA_WIDGETS_TYPE_CAMERA_VIEW);
#line 2340 "CameraView.c"
}

guint
camera_widgets_camera_view_get_n_cameras (CameraWidgetsCameraView* self)
{
	guint result;
	GstDeviceMonitor* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	guint _tmp3_;
#line 42 "../src/Widgets/CameraView.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 43 "../src/Widgets/CameraView.vala"
	_tmp0_ = self->priv->monitor;
#line 43 "../src/Widgets/CameraView.vala"
	_tmp1_ = gst_device_monitor_get_devices (_tmp0_);
#line 43 "../src/Widgets/CameraView.vala"
	_tmp2_ = _tmp1_;
#line 43 "../src/Widgets/CameraView.vala"
	_tmp3_ = g_list_length (_tmp2_);
#line 43 "../src/Widgets/CameraView.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 43 "../src/Widgets/CameraView.vala"
	result = _tmp3_;
#line 43 "../src/Widgets/CameraView.vala"
	return result;
#line 2367 "CameraView.c"
}

gboolean
camera_widgets_camera_view_get_recording (CameraWidgetsCameraView* self)
{
	gboolean result;
#line 51 "../src/Widgets/CameraView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/Widgets/CameraView.vala"
	result = self->priv->_recording;
#line 51 "../src/Widgets/CameraView.vala"
	return result;
#line 2380 "CameraView.c"
}

static void
camera_widgets_camera_view_set_recording (CameraWidgetsCameraView* self,
                                          gboolean value)
{
	gboolean old_value;
#line 51 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/Widgets/CameraView.vala"
	old_value = camera_widgets_camera_view_get_recording (self);
#line 51 "../src/Widgets/CameraView.vala"
	if (old_value != value) {
#line 51 "../src/Widgets/CameraView.vala"
		self->priv->_recording = value;
#line 51 "../src/Widgets/CameraView.vala"
		g_object_notify_by_pspec ((GObject *) self, camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY]);
#line 2398 "CameraView.c"
	}
}

gboolean
camera_widgets_camera_view_get_horizontal_flip (CameraWidgetsCameraView* self)
{
	gboolean result;
	GstVideoDirection* _tmp0_;
	GstVideoDirection* _tmp1_;
	GstVideoOrientationMethod _tmp2_;
	GstVideoOrientationMethod _tmp3_;
#line 53 "../src/Widgets/CameraView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/Widgets/CameraView.vala"
	_tmp0_ = self->priv->hflip;
#line 54 "../src/Widgets/CameraView.vala"
	if (_tmp0_ == NULL) {
#line 55 "../src/Widgets/CameraView.vala"
		result = TRUE;
#line 55 "../src/Widgets/CameraView.vala"
		return result;
#line 2420 "CameraView.c"
	}
#line 58 "../src/Widgets/CameraView.vala"
	_tmp1_ = self->priv->hflip;
#line 58 "../src/Widgets/CameraView.vala"
	g_object_get (_tmp1_, "video-direction", &_tmp2_, NULL);
#line 58 "../src/Widgets/CameraView.vala"
	_tmp3_ = _tmp2_;
#line 58 "../src/Widgets/CameraView.vala"
	result = _tmp3_ == GST_VIDEO_ORIENTATION_HORIZ;
#line 58 "../src/Widgets/CameraView.vala"
	return result;
#line 2432 "CameraView.c"
}

void
camera_widgets_camera_view_set_horizontal_flip (CameraWidgetsCameraView* self,
                                                gboolean value)
{
	GstVideoDirection* _tmp0_;
	GstVideoDirection* _tmp1_;
	GstVideoOrientationMethod _tmp2_;
	GstVideoOrientationMethod _tmp3_;
#line 60 "../src/Widgets/CameraView.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/Widgets/CameraView.vala"
	_tmp0_ = self->priv->hflip;
#line 61 "../src/Widgets/CameraView.vala"
	if (_tmp0_ == NULL) {
#line 62 "../src/Widgets/CameraView.vala"
		return;
#line 2451 "CameraView.c"
	}
#line 65 "../src/Widgets/CameraView.vala"
	_tmp1_ = self->priv->hflip;
#line 65 "../src/Widgets/CameraView.vala"
	g_object_get (_tmp1_, "video-direction", &_tmp2_, NULL);
#line 65 "../src/Widgets/CameraView.vala"
	_tmp3_ = _tmp2_;
#line 65 "../src/Widgets/CameraView.vala"
	if (_tmp3_ == GST_VIDEO_ORIENTATION_IDENTITY) {
#line 2461 "CameraView.c"
		GstVideoDirection* _tmp4_;
#line 66 "../src/Widgets/CameraView.vala"
		_tmp4_ = self->priv->hflip;
#line 66 "../src/Widgets/CameraView.vala"
		g_object_set (_tmp4_, "video-direction", GST_VIDEO_ORIENTATION_HORIZ, NULL);
#line 2467 "CameraView.c"
	} else {
		GstVideoDirection* _tmp5_;
#line 68 "../src/Widgets/CameraView.vala"
		_tmp5_ = self->priv->hflip;
#line 68 "../src/Widgets/CameraView.vala"
		g_object_set (_tmp5_, "video-direction", GST_VIDEO_ORIENTATION_IDENTITY, NULL);
#line 2474 "CameraView.c"
	}
#line 60 "../src/Widgets/CameraView.vala"
	g_object_notify_by_pspec ((GObject *) self, camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY]);
#line 2478 "CameraView.c"
}

static gboolean
_camera_widgets_camera_view_on_bus_message_gst_bus_func (GstBus* bus,
                                                         GstMessage* message,
                                                         gpointer self)
{
	gboolean result;
	result = camera_widgets_camera_view_on_bus_message ((CameraWidgetsCameraView*) self, bus, message);
#line 105 "../src/Widgets/CameraView.vala"
	return result;
#line 2490 "CameraView.c"
}

static gboolean
_camera_widgets_camera_view___lambda9_ (CameraWidgetsCameraView* self)
{
	guint _tmp0_;
	guint _tmp1_;
	gboolean result;
#line 114 "../src/Widgets/CameraView.vala"
	_tmp0_ = camera_widgets_camera_view_get_n_cameras (self);
#line 114 "../src/Widgets/CameraView.vala"
	_tmp1_ = _tmp0_;
#line 114 "../src/Widgets/CameraView.vala"
	if (_tmp1_ == ((guint) 0)) {
#line 2505 "CameraView.c"
		GranitePlaceholder* _tmp2_;
		GtkStack* _tmp3_;
		GranitePlaceholder* _tmp4_;
#line 115 "../src/Widgets/CameraView.vala"
		_tmp2_ = self->priv->no_device_view;
#line 115 "../src/Widgets/CameraView.vala"
		gtk_widget_show ((GtkWidget*) _tmp2_);
#line 116 "../src/Widgets/CameraView.vala"
		_tmp3_ = self->priv->stack;
#line 116 "../src/Widgets/CameraView.vala"
		_tmp4_ = self->priv->no_device_view;
#line 116 "../src/Widgets/CameraView.vala"
		gtk_stack_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
#line 2519 "CameraView.c"
	}
#line 118 "../src/Widgets/CameraView.vala"
	result = G_SOURCE_REMOVE;
#line 118 "../src/Widgets/CameraView.vala"
	return result;
#line 2525 "CameraView.c"
}

static gboolean
__camera_widgets_camera_view___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = _camera_widgets_camera_view___lambda9_ ((CameraWidgetsCameraView*) self);
#line 113 "../src/Widgets/CameraView.vala"
	return result;
#line 2535 "CameraView.c"
}

static GObject *
camera_widgets_camera_view_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CameraWidgetsCameraView * self;
	GtkSpinner* spinner = NULL;
	GtkSpinner* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	GtkBox* _tmp2_ = NULL;
	GtkBox* _tmp3_;
	GtkSpinner* _tmp4_;
	GtkBox* _tmp5_;
	GtkLabel* _tmp6_;
	gchar* _tmp7_;
	GranitePlaceholder* _tmp8_ = NULL;
	GtkPicture* _tmp9_ = NULL;
	GtkStack* _tmp10_;
	GtkStack* _tmp11_;
	GtkBox* _tmp12_;
	GtkStack* _tmp13_;
	GranitePlaceholder* _tmp14_;
	GtkStack* _tmp15_;
	GtkPicture* _tmp16_;
	GstDeviceMonitor* _tmp17_;
	GstBus* _tmp18_;
	GstBus* _tmp19_;
	GtkStack* _tmp20_;
	GstCaps* caps = NULL;
	GstCaps* _tmp21_;
	GstCaps* _tmp22_;
	GstCaps* _tmp23_;
	GstDeviceMonitor* _tmp24_;
	GstCaps* _tmp25_;
#line 76 "../src/Widgets/CameraView.vala"
	parent_class = G_OBJECT_CLASS (camera_widgets_camera_view_parent_class);
#line 76 "../src/Widgets/CameraView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 76 "../src/Widgets/CameraView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView);
#line 77 "../src/Widgets/CameraView.vala"
	_tmp0_ = (GtkSpinner*) gtk_spinner_new ();
#line 77 "../src/Widgets/CameraView.vala"
	gtk_spinner_set_spinning (_tmp0_, TRUE);
#line 77 "../src/Widgets/CameraView.vala"
	g_object_ref_sink (_tmp0_);
#line 77 "../src/Widgets/CameraView.vala"
	spinner = _tmp0_;
#line 81 "../src/Widgets/CameraView.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
#line 81 "../src/Widgets/CameraView.vala"
	g_object_ref_sink (_tmp1_);
#line 81 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->status_label);
#line 81 "../src/Widgets/CameraView.vala"
	self->priv->status_label = _tmp1_;
#line 83 "../src/Widgets/CameraView.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 83 "../src/Widgets/CameraView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 83 "../src/Widgets/CameraView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 83 "../src/Widgets/CameraView.vala"
	g_object_ref_sink (_tmp2_);
#line 83 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->status_box);
#line 83 "../src/Widgets/CameraView.vala"
	self->priv->status_box = _tmp2_;
#line 87 "../src/Widgets/CameraView.vala"
	_tmp3_ = self->priv->status_box;
#line 87 "../src/Widgets/CameraView.vala"
	_tmp4_ = spinner;
#line 87 "../src/Widgets/CameraView.vala"
	gtk_box_append (_tmp3_, (GtkWidget*) _tmp4_);
#line 88 "../src/Widgets/CameraView.vala"
	_tmp5_ = self->priv->status_box;
#line 88 "../src/Widgets/CameraView.vala"
	_tmp6_ = self->priv->status_label;
#line 88 "../src/Widgets/CameraView.vala"
	gtk_box_append (_tmp5_, (GtkWidget*) _tmp6_);
#line 90 "../src/Widgets/CameraView.vala"
	_tmp7_ = g_strdup (_ ("Connect a webcam or other supported video device to take photos and vi" \
"deo."));
#line 90 "../src/Widgets/CameraView.vala"
	_tmp8_ = granite_placeholder_new (_ ("No Supported Camera Found"));
#line 90 "../src/Widgets/CameraView.vala"
	granite_placeholder_set_description (_tmp8_, _tmp7_);
#line 90 "../src/Widgets/CameraView.vala"
	_g_free0 (_tmp7_);
#line 90 "../src/Widgets/CameraView.vala"
	g_object_ref_sink (_tmp8_);
#line 90 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->no_device_view);
#line 90 "../src/Widgets/CameraView.vala"
	self->priv->no_device_view = _tmp8_;
#line 94 "../src/Widgets/CameraView.vala"
	_tmp9_ = (GtkPicture*) gtk_picture_new ();
#line 94 "../src/Widgets/CameraView.vala"
	gtk_picture_set_content_fit (_tmp9_, GTK_CONTENT_FIT_CONTAIN);
#line 94 "../src/Widgets/CameraView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp9_, TRUE);
#line 94 "../src/Widgets/CameraView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp9_, TRUE);
#line 94 "../src/Widgets/CameraView.vala"
	g_object_ref_sink (_tmp9_);
#line 94 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->picture);
#line 94 "../src/Widgets/CameraView.vala"
	self->priv->picture = _tmp9_;
#line 100 "../src/Widgets/CameraView.vala"
	_tmp10_ = (GtkStack*) gtk_stack_new ();
#line 100 "../src/Widgets/CameraView.vala"
	g_object_ref_sink (_tmp10_);
#line 100 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->stack);
#line 100 "../src/Widgets/CameraView.vala"
	self->priv->stack = _tmp10_;
#line 101 "../src/Widgets/CameraView.vala"
	_tmp11_ = self->priv->stack;
#line 101 "../src/Widgets/CameraView.vala"
	_tmp12_ = self->priv->status_box;
#line 101 "../src/Widgets/CameraView.vala"
	gtk_stack_add_child (_tmp11_, (GtkWidget*) _tmp12_);
#line 102 "../src/Widgets/CameraView.vala"
	_tmp13_ = self->priv->stack;
#line 102 "../src/Widgets/CameraView.vala"
	_tmp14_ = self->priv->no_device_view;
#line 102 "../src/Widgets/CameraView.vala"
	gtk_stack_add_child (_tmp13_, (GtkWidget*) _tmp14_);
#line 103 "../src/Widgets/CameraView.vala"
	_tmp15_ = self->priv->stack;
#line 103 "../src/Widgets/CameraView.vala"
	_tmp16_ = self->priv->picture;
#line 103 "../src/Widgets/CameraView.vala"
	gtk_stack_add_child (_tmp15_, (GtkWidget*) _tmp16_);
#line 105 "../src/Widgets/CameraView.vala"
	_tmp17_ = self->priv->monitor;
#line 105 "../src/Widgets/CameraView.vala"
	_tmp18_ = gst_device_monitor_get_bus (_tmp17_);
#line 105 "../src/Widgets/CameraView.vala"
	_tmp19_ = _tmp18_;
#line 105 "../src/Widgets/CameraView.vala"
	gst_bus_add_watch_full (_tmp19_, G_PRIORITY_DEFAULT, _camera_widgets_camera_view_on_bus_message_gst_bus_func, g_object_ref (self), g_object_unref);
#line 105 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (_tmp19_);
#line 107 "../src/Widgets/CameraView.vala"
	_tmp20_ = self->priv->stack;
#line 107 "../src/Widgets/CameraView.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp20_);
#line 109 "../src/Widgets/CameraView.vala"
	_tmp21_ = gst_caps_new_empty_simple ("video/x-raw");
#line 109 "../src/Widgets/CameraView.vala"
	caps = _tmp21_;
#line 110 "../src/Widgets/CameraView.vala"
	_tmp22_ = caps;
#line 110 "../src/Widgets/CameraView.vala"
	_tmp23_ = gst_caps_new_empty_simple ("image/jpeg");
#line 110 "../src/Widgets/CameraView.vala"
	gst_caps_append (_tmp22_, _tmp23_);
#line 111 "../src/Widgets/CameraView.vala"
	_tmp24_ = self->priv->monitor;
#line 111 "../src/Widgets/CameraView.vala"
	_tmp25_ = caps;
#line 111 "../src/Widgets/CameraView.vala"
	gst_device_monitor_add_filter (_tmp24_, "Video/Source", _tmp25_);
#line 113 "../src/Widgets/CameraView.vala"
	self->priv->init_device_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, __camera_widgets_camera_view___lambda9__gsource_func, g_object_ref (self), g_object_unref);
#line 76 "../src/Widgets/CameraView.vala"
	_gst_caps_unref0 (caps);
#line 76 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (spinner);
#line 76 "../src/Widgets/CameraView.vala"
	return obj;
#line 2712 "CameraView.c"
}

static void
camera_widgets_camera_view_class_init (CameraWidgetsCameraViewClass * klass,
                                       gpointer klass_data)
{
#line 23 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Widgets/CameraView.vala"
	g_type_class_adjust_private_offset (klass, &CameraWidgetsCameraView_private_offset);
#line 23 "../src/Widgets/CameraView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_camera_widgets_camera_view_get_property;
#line 23 "../src/Widgets/CameraView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_camera_widgets_camera_view_set_property;
#line 23 "../src/Widgets/CameraView.vala"
	G_OBJECT_CLASS (klass)->constructor = camera_widgets_camera_view_constructor;
#line 23 "../src/Widgets/CameraView.vala"
	G_OBJECT_CLASS (klass)->finalize = camera_widgets_camera_view_finalize;
#line 23 "../src/Widgets/CameraView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_WIDGETS_CAMERA_VIEW_N_CAMERAS_PROPERTY, camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_N_CAMERAS_PROPERTY] = g_param_spec_uint ("n-cameras", "n-cameras", "n-cameras", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Widgets/CameraView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY, camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY] = g_param_spec_boolean ("recording", "recording", "recording", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Widgets/CameraView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY, camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY] = g_param_spec_boolean ("horizontal-flip", "horizontal-flip", "horizontal-flip", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_FINISHED_SIGNAL] = g_signal_new ("recording-finished", CAMERA_WIDGETS_TYPE_CAMERA_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 23 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_ADDED_SIGNAL] = g_signal_new ("camera-added", CAMERA_WIDGETS_TYPE_CAMERA_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gst_device_get_type ());
#line 23 "../src/Widgets/CameraView.vala"
	camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_REMOVED_SIGNAL] = g_signal_new ("camera-removed", CAMERA_WIDGETS_TYPE_CAMERA_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gst_device_get_type ());
#line 2743 "CameraView.c"
}

static void
camera_widgets_camera_view_instance_init (CameraWidgetsCameraView * self,
                                          gpointer klass)
{
	GstDeviceMonitor* _tmp0_;
#line 23 "../src/Widgets/CameraView.vala"
	self->priv = camera_widgets_camera_view_get_instance_private (self);
#line 38 "../src/Widgets/CameraView.vala"
	self->priv->current_device = NULL;
#line 39 "../src/Widgets/CameraView.vala"
	self->priv->init_device_timeout_id = (guint) 0;
#line 50 "../src/Widgets/CameraView.vala"
	_tmp0_ = gst_device_monitor_new ();
#line 50 "../src/Widgets/CameraView.vala"
	g_object_ref_sink (_tmp0_);
#line 50 "../src/Widgets/CameraView.vala"
	self->priv->monitor = _tmp0_;
#line 51 "../src/Widgets/CameraView.vala"
	self->priv->_recording = FALSE;
#line 2765 "CameraView.c"
}

static void
camera_widgets_camera_view_finalize (GObject * obj)
{
	CameraWidgetsCameraView * self;
#line 23 "../src/Widgets/CameraView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView);
#line 27 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->stack);
#line 28 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->status_box);
#line 29 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->no_device_view);
#line 30 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->status_label);
#line 31 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->picture);
#line 33 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 34 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->tee);
#line 35 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->color_balance);
#line 36 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->hflip);
#line 37 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->record_bin);
#line 38 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->current_device);
#line 50 "../src/Widgets/CameraView.vala"
	_g_object_unref0 (self->priv->monitor);
#line 23 "../src/Widgets/CameraView.vala"
	G_OBJECT_CLASS (camera_widgets_camera_view_parent_class)->finalize (obj);
#line 2800 "CameraView.c"
}

static GType
camera_widgets_camera_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CameraWidgetsCameraViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_widgets_camera_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraWidgetsCameraView), 0, (GInstanceInitFunc) camera_widgets_camera_view_instance_init, NULL };
	GType camera_widgets_camera_view_type_id;
	camera_widgets_camera_view_type_id = g_type_register_static (gtk_box_get_type (), "CameraWidgetsCameraView", &g_define_type_info, 0);
	CameraWidgetsCameraView_private_offset = g_type_add_instance_private (camera_widgets_camera_view_type_id, sizeof (CameraWidgetsCameraViewPrivate));
	return camera_widgets_camera_view_type_id;
}

GType
camera_widgets_camera_view_get_type (void)
{
	static volatile gsize camera_widgets_camera_view_type_id__once = 0;
	if (g_once_init_enter (&camera_widgets_camera_view_type_id__once)) {
		GType camera_widgets_camera_view_type_id;
		camera_widgets_camera_view_type_id = camera_widgets_camera_view_get_type_once ();
		g_once_init_leave (&camera_widgets_camera_view_type_id__once, camera_widgets_camera_view_type_id);
	}
	return camera_widgets_camera_view_type_id__once;
}

static void
_vala_camera_widgets_camera_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	CameraWidgetsCameraView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView);
#line 23 "../src/Widgets/CameraView.vala"
	switch (property_id) {
#line 23 "../src/Widgets/CameraView.vala"
		case CAMERA_WIDGETS_CAMERA_VIEW_N_CAMERAS_PROPERTY:
#line 23 "../src/Widgets/CameraView.vala"
		g_value_set_uint (value, camera_widgets_camera_view_get_n_cameras (self));
#line 23 "../src/Widgets/CameraView.vala"
		break;
#line 23 "../src/Widgets/CameraView.vala"
		case CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY:
#line 23 "../src/Widgets/CameraView.vala"
		g_value_set_boolean (value, camera_widgets_camera_view_get_recording (self));
#line 23 "../src/Widgets/CameraView.vala"
		break;
#line 23 "../src/Widgets/CameraView.vala"
		case CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY:
#line 23 "../src/Widgets/CameraView.vala"
		g_value_set_boolean (value, camera_widgets_camera_view_get_horizontal_flip (self));
#line 23 "../src/Widgets/CameraView.vala"
		break;
#line 2853 "CameraView.c"
		default:
#line 23 "../src/Widgets/CameraView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/CameraView.vala"
		break;
#line 2859 "CameraView.c"
	}
}

static void
_vala_camera_widgets_camera_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	CameraWidgetsCameraView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView);
#line 23 "../src/Widgets/CameraView.vala"
	switch (property_id) {
#line 23 "../src/Widgets/CameraView.vala"
		case CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY:
#line 23 "../src/Widgets/CameraView.vala"
		camera_widgets_camera_view_set_recording (self, g_value_get_boolean (value));
#line 23 "../src/Widgets/CameraView.vala"
		break;
#line 23 "../src/Widgets/CameraView.vala"
		case CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY:
#line 23 "../src/Widgets/CameraView.vala"
		camera_widgets_camera_view_set_horizontal_flip (self, g_value_get_boolean (value));
#line 23 "../src/Widgets/CameraView.vala"
		break;
#line 2885 "CameraView.c"
		default:
#line 23 "../src/Widgets/CameraView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/CameraView.vala"
		break;
#line 2891 "CameraView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

