/* TimerButton.c generated by valac 0.56.18, the Vala compiler
 * generated from TimerButton.vala, do not modify */

/*
 * Copyright 2011-2024 elementary, Inc. (https://github.com/elementary/camera)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Alain M. <alain23@protonmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CAMERA_WIDGETS_TYPE_TIMER_BUTTON (camera_widgets_timer_button_get_type ())
#define CAMERA_WIDGETS_TIMER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton))
#define CAMERA_WIDGETS_TIMER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButtonClass))
#define CAMERA_WIDGETS_IS_TIMER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON))
#define CAMERA_WIDGETS_IS_TIMER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_WIDGETS_TYPE_TIMER_BUTTON))
#define CAMERA_WIDGETS_TIMER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButtonClass))

typedef struct _CameraWidgetsTimerButton CameraWidgetsTimerButton;
typedef struct _CameraWidgetsTimerButtonClass CameraWidgetsTimerButtonClass;
typedef struct _CameraWidgetsTimerButtonPrivate CameraWidgetsTimerButtonPrivate;
typedef enum  {
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED = 0,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC = 3,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC = 5,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC = 10
} CameraWidgetsTimerButtonDelay;

#define CAMERA_WIDGETS_TIMER_BUTTON_TYPE_DELAY (camera_widgets_timer_button_delay_get_type ())
enum  {
	CAMERA_WIDGETS_TIMER_BUTTON_0_PROPERTY,
	CAMERA_WIDGETS_TIMER_BUTTON_NUM_PROPERTIES
};
static GParamSpec* camera_widgets_timer_button_properties[CAMERA_WIDGETS_TIMER_BUTTON_NUM_PROPERTIES];
typedef struct _Block7Data Block7Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _CameraWidgetsTimerButton {
	GtkButton parent_instance;
	CameraWidgetsTimerButtonPrivate * priv;
	CameraWidgetsTimerButtonDelay delay;
};

struct _CameraWidgetsTimerButtonClass {
	GtkButtonClass parent_class;
};

struct _Block7Data {
	int _ref_count_;
	CameraWidgetsTimerButton* self;
	GtkLabel* label_widget;
};

static gpointer camera_widgets_timer_button_parent_class = NULL;
VALA_EXTERN GSettings* camera_application_settings;

VALA_EXTERN GType camera_widgets_timer_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraWidgetsTimerButton, g_object_unref)
VALA_EXTERN GType camera_widgets_timer_button_delay_get_type (void) G_GNUC_CONST ;
VALA_EXTERN CameraWidgetsTimerButtonDelay camera_widgets_timer_button_delay_next (CameraWidgetsTimerButtonDelay self);
VALA_EXTERN gchar* camera_widgets_timer_button_delay_to_string (CameraWidgetsTimerButtonDelay self);
VALA_EXTERN CameraWidgetsTimerButton* camera_widgets_timer_button_new (void);
VALA_EXTERN CameraWidgetsTimerButton* camera_widgets_timer_button_construct (GType object_type);
static GObject * camera_widgets_timer_button_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _camera_widgets_timer_button___lambda10_ (Block7Data* _data7_);
static void __camera_widgets_timer_button___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void camera_widgets_timer_button_finalize (GObject * obj);
static GType camera_widgets_timer_button_get_type_once (void);

CameraWidgetsTimerButtonDelay
camera_widgets_timer_button_delay_next (CameraWidgetsTimerButtonDelay self)
{
	CameraWidgetsTimerButtonDelay result;
#line 29 "../src/Widgets/TimerButton.vala"
	switch (self) {
#line 29 "../src/Widgets/TimerButton.vala"
		case CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC:
#line 124 "TimerButton.c"
		{
#line 31 "../src/Widgets/TimerButton.vala"
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC;
#line 31 "../src/Widgets/TimerButton.vala"
			return result;
#line 130 "TimerButton.c"
		}
#line 29 "../src/Widgets/TimerButton.vala"
		case CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC:
#line 134 "TimerButton.c"
		{
#line 33 "../src/Widgets/TimerButton.vala"
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC;
#line 33 "../src/Widgets/TimerButton.vala"
			return result;
#line 140 "TimerButton.c"
		}
#line 29 "../src/Widgets/TimerButton.vala"
		case CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC:
#line 144 "TimerButton.c"
		{
#line 35 "../src/Widgets/TimerButton.vala"
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED;
#line 35 "../src/Widgets/TimerButton.vala"
			return result;
#line 150 "TimerButton.c"
		}
		default:
		{
#line 37 "../src/Widgets/TimerButton.vala"
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC;
#line 37 "../src/Widgets/TimerButton.vala"
			return result;
#line 158 "TimerButton.c"
		}
	}
}

gchar*
camera_widgets_timer_button_delay_to_string (CameraWidgetsTimerButtonDelay self)
{
	gchar* result;
#line 41 "../src/Widgets/TimerButton.vala"
	if (self == CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED) {
#line 169 "TimerButton.c"
		gchar* _tmp0_;
#line 42 "../src/Widgets/TimerButton.vala"
		_tmp0_ = g_strdup (_ ("Disabled"));
#line 42 "../src/Widgets/TimerButton.vala"
		result = _tmp0_;
#line 42 "../src/Widgets/TimerButton.vala"
		return result;
#line 177 "TimerButton.c"
	} else {
		gchar* _tmp1_;
#line 45 "../src/Widgets/TimerButton.vala"
		_tmp1_ = g_strdup_printf (ngettext ("%d Sec", "%d Sec", (gulong) self), (gint) self);
#line 45 "../src/Widgets/TimerButton.vala"
		result = _tmp1_;
#line 45 "../src/Widgets/TimerButton.vala"
		return result;
#line 186 "TimerButton.c"
	}
}

static GType
camera_widgets_timer_button_delay_get_type_once (void)
{
	static const GEnumValue values[] = {{CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED", "disabled"}, {CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC", "3-sec"}, {CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC", "5-sec"}, {CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC", "10-sec"}, {0, NULL, NULL}};
	GType camera_widgets_timer_button_delay_type_id;
	camera_widgets_timer_button_delay_type_id = g_enum_register_static ("CameraWidgetsTimerButtonDelay", values);
	return camera_widgets_timer_button_delay_type_id;
}

GType
camera_widgets_timer_button_delay_get_type (void)
{
	static volatile gsize camera_widgets_timer_button_delay_type_id__once = 0;
	if (g_once_init_enter (&camera_widgets_timer_button_delay_type_id__once)) {
		GType camera_widgets_timer_button_delay_type_id;
		camera_widgets_timer_button_delay_type_id = camera_widgets_timer_button_delay_get_type_once ();
		g_once_init_leave (&camera_widgets_timer_button_delay_type_id__once, camera_widgets_timer_button_delay_type_id);
	}
	return camera_widgets_timer_button_delay_type_id__once;
}

CameraWidgetsTimerButton*
camera_widgets_timer_button_construct (GType object_type)
{
	CameraWidgetsTimerButton * self = NULL;
#line 22 "../src/Widgets/TimerButton.vala"
	self = (CameraWidgetsTimerButton*) g_object_new (object_type, NULL);
#line 22 "../src/Widgets/TimerButton.vala"
	return self;
#line 219 "TimerButton.c"
}

CameraWidgetsTimerButton*
camera_widgets_timer_button_new (void)
{
#line 22 "../src/Widgets/TimerButton.vala"
	return camera_widgets_timer_button_construct (CAMERA_WIDGETS_TYPE_TIMER_BUTTON);
#line 227 "TimerButton.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 52 "../src/Widgets/TimerButton.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 52 "../src/Widgets/TimerButton.vala"
	return _data7_;
#line 237 "TimerButton.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 52 "../src/Widgets/TimerButton.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 247 "TimerButton.c"
		CameraWidgetsTimerButton* self;
#line 52 "../src/Widgets/TimerButton.vala"
		self = _data7_->self;
#line 52 "../src/Widgets/TimerButton.vala"
		_g_object_unref0 (_data7_->label_widget);
#line 52 "../src/Widgets/TimerButton.vala"
		_g_object_unref0 (self);
#line 52 "../src/Widgets/TimerButton.vala"
		g_slice_free (Block7Data, _data7_);
#line 257 "TimerButton.c"
	}
}

static void
_camera_widgets_timer_button___lambda10_ (Block7Data* _data7_)
{
	CameraWidgetsTimerButton* self;
	GSettings* _tmp0_;
	GtkLabel* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 67 "../src/Widgets/TimerButton.vala"
	self = _data7_->self;
#line 68 "../src/Widgets/TimerButton.vala"
	self->delay = camera_widgets_timer_button_delay_next (self->delay);
#line 69 "../src/Widgets/TimerButton.vala"
	_tmp0_ = camera_application_settings;
#line 69 "../src/Widgets/TimerButton.vala"
	g_settings_set_enum (_tmp0_, "delay", (gint) self->delay);
#line 70 "../src/Widgets/TimerButton.vala"
	_tmp1_ = _data7_->label_widget;
#line 70 "../src/Widgets/TimerButton.vala"
	_tmp2_ = camera_widgets_timer_button_delay_to_string (self->delay);
#line 70 "../src/Widgets/TimerButton.vala"
	_tmp3_ = _tmp2_;
#line 70 "../src/Widgets/TimerButton.vala"
	gtk_label_set_label (_tmp1_, _tmp3_);
#line 70 "../src/Widgets/TimerButton.vala"
	_g_free0 (_tmp3_);
#line 287 "TimerButton.c"
}

static void
__camera_widgets_timer_button___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 67 "../src/Widgets/TimerButton.vala"
	_camera_widgets_timer_button___lambda10_ (self);
#line 296 "TimerButton.c"
}

static GObject *
camera_widgets_timer_button_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CameraWidgetsTimerButton * self;
	Block7Data* _data7_;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel* _tmp4_;
	GtkBox* box = NULL;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkBox* _tmp9_;
	GtkLabel* _tmp10_;
	GtkBox* _tmp11_;
#line 52 "../src/Widgets/TimerButton.vala"
	parent_class = G_OBJECT_CLASS (camera_widgets_timer_button_parent_class);
#line 52 "../src/Widgets/TimerButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 52 "../src/Widgets/TimerButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton);
#line 52 "../src/Widgets/TimerButton.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 52 "../src/Widgets/TimerButton.vala"
	_data7_->_ref_count_ = 1;
#line 52 "../src/Widgets/TimerButton.vala"
	_data7_->self = g_object_ref (self);
#line 53 "../src/Widgets/TimerButton.vala"
	_tmp0_ = camera_application_settings;
#line 53 "../src/Widgets/TimerButton.vala"
	self->delay = (CameraWidgetsTimerButtonDelay) g_settings_get_enum (_tmp0_, "delay");
#line 55 "../src/Widgets/TimerButton.vala"
	_tmp1_ = camera_widgets_timer_button_delay_to_string (self->delay);
#line 55 "../src/Widgets/TimerButton.vala"
	_tmp2_ = _tmp1_;
#line 55 "../src/Widgets/TimerButton.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
#line 55 "../src/Widgets/TimerButton.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp3_, 3);
#line 55 "../src/Widgets/TimerButton.vala"
	g_object_ref_sink (_tmp3_);
#line 55 "../src/Widgets/TimerButton.vala"
	_tmp4_ = _tmp3_;
#line 55 "../src/Widgets/TimerButton.vala"
	_g_free0 (_tmp2_);
#line 55 "../src/Widgets/TimerButton.vala"
	_data7_->label_widget = _tmp4_;
#line 59 "../src/Widgets/TimerButton.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 59 "../src/Widgets/TimerButton.vala"
	g_object_ref_sink (_tmp5_);
#line 59 "../src/Widgets/TimerButton.vala"
	box = _tmp5_;
#line 60 "../src/Widgets/TimerButton.vala"
	_tmp6_ = box;
#line 60 "../src/Widgets/TimerButton.vala"
	_tmp7_ = (GtkImage*) gtk_image_new_from_icon_name ("timer-symbolic");
#line 60 "../src/Widgets/TimerButton.vala"
	g_object_ref_sink (_tmp7_);
#line 60 "../src/Widgets/TimerButton.vala"
	_tmp8_ = _tmp7_;
#line 60 "../src/Widgets/TimerButton.vala"
	gtk_box_append (_tmp6_, (GtkWidget*) _tmp8_);
#line 60 "../src/Widgets/TimerButton.vala"
	_g_object_unref0 (_tmp8_);
#line 61 "../src/Widgets/TimerButton.vala"
	_tmp9_ = box;
#line 61 "../src/Widgets/TimerButton.vala"
	_tmp10_ = _data7_->label_widget;
#line 61 "../src/Widgets/TimerButton.vala"
	gtk_box_append (_tmp9_, (GtkWidget*) _tmp10_);
#line 63 "../src/Widgets/TimerButton.vala"
	_tmp11_ = box;
#line 63 "../src/Widgets/TimerButton.vala"
	gtk_button_set_child ((GtkButton*) self, (GtkWidget*) _tmp11_);
#line 64 "../src/Widgets/TimerButton.vala"
	gtk_button_set_has_frame ((GtkButton*) self, FALSE);
#line 65 "../src/Widgets/TimerButton.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Delay before photo is taken"));
#line 67 "../src/Widgets/TimerButton.vala"
	g_signal_connect_data ((GtkButton*) self, "clicked", (GCallback) __camera_widgets_timer_button___lambda10__gtk_button_clicked, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 52 "../src/Widgets/TimerButton.vala"
	_g_object_unref0 (box);
#line 52 "../src/Widgets/TimerButton.vala"
	block7_data_unref (_data7_);
#line 52 "../src/Widgets/TimerButton.vala"
	_data7_ = NULL;
#line 52 "../src/Widgets/TimerButton.vala"
	return obj;
#line 395 "TimerButton.c"
}

static void
camera_widgets_timer_button_class_init (CameraWidgetsTimerButtonClass * klass,
                                        gpointer klass_data)
{
#line 22 "../src/Widgets/TimerButton.vala"
	camera_widgets_timer_button_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/TimerButton.vala"
	G_OBJECT_CLASS (klass)->constructor = camera_widgets_timer_button_constructor;
#line 22 "../src/Widgets/TimerButton.vala"
	G_OBJECT_CLASS (klass)->finalize = camera_widgets_timer_button_finalize;
#line 408 "TimerButton.c"
}

static void
camera_widgets_timer_button_instance_init (CameraWidgetsTimerButton * self,
                                           gpointer klass)
{
}

static void
camera_widgets_timer_button_finalize (GObject * obj)
{
	CameraWidgetsTimerButton * self;
#line 22 "../src/Widgets/TimerButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton);
#line 22 "../src/Widgets/TimerButton.vala"
	G_OBJECT_CLASS (camera_widgets_timer_button_parent_class)->finalize (obj);
#line 425 "TimerButton.c"
}

static GType
camera_widgets_timer_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CameraWidgetsTimerButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_widgets_timer_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraWidgetsTimerButton), 0, (GInstanceInitFunc) camera_widgets_timer_button_instance_init, NULL };
	GType camera_widgets_timer_button_type_id;
	camera_widgets_timer_button_type_id = g_type_register_static (gtk_button_get_type (), "CameraWidgetsTimerButton", &g_define_type_info, 0);
	return camera_widgets_timer_button_type_id;
}

GType
camera_widgets_timer_button_get_type (void)
{
	static volatile gsize camera_widgets_timer_button_type_id__once = 0;
	if (g_once_init_enter (&camera_widgets_timer_button_type_id__once)) {
		GType camera_widgets_timer_button_type_id;
		camera_widgets_timer_button_type_id = camera_widgets_timer_button_get_type_once ();
		g_once_init_leave (&camera_widgets_timer_button_type_id__once, camera_widgets_timer_button_type_id);
	}
	return camera_widgets_timer_button_type_id__once;
}

